// $ANTLR 3.3 Nov 30, 2010 12:46:29 net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g 2011-10-14 10:09:15

/*
 * The contents of this file are subject to the Mozilla Public License 
 * Version 1.1 (the "License"); you may not use this file except in 
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS" 
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific language governing rights and limitations 
 * under the License.
 * 
 * The Original Code is the NRL Parser, released 28 April 2006, 
 * Copyright (c) Christian Nentwich. The Initial Developer of the 
 * Original Code is Christian Nentwich. Portions created by contributors 
 * identified in the NOTICES file are Copyright (c) the contributors. 
 * All Rights Reserved. 
 */
package net.sourceforge.nrl.parser.ast.impl;
	
import net.sourceforge.nrl.parser.ast.constraints.IArithmeticExpression;
import net.sourceforge.nrl.parser.ast.constraints.IExpression;
import net.sourceforge.nrl.parser.IStatusCode;
import net.sourceforge.nrl.parser.SyntaxError;
import net.sourceforge.nrl.parser.NRLError;
import net.sourceforge.nrl.parser.ast.constraints.impl.VariableDeclarationImpl;	
import net.sourceforge.nrl.parser.ast.constraints.impl.ModelReferenceImpl;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;

import org.antlr.runtime.tree.*;

public class NRLActionParser extends Parser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "VT_COMPOUND_REPORT", "VT_CONCATENATED_REPORT", "VT_CONDITIONAL_REPORT", "VT_NAMED_PARAMETER", "VT_ENUMERATOR", "VT_EXISTS", "VT_FIRST_ORDINAL_NUMBER", "VT_MODELREFERENCE", "VT_MULTIPLE_EXISTS", "VT_MULTIPLE_NOTEXISTS", "VT_NEGATE_DECIMAL", "VT_NEGATE_INTEGER", "VT_RULEFILE", "VT_SELECTION_EXPR", "VT_SINGLE_SELECTION_EXPR", "VT_VARIABLE_DECLARATION", "VALIDATION_RULE", "DOUBLE_QUOTED_STRING", "APPLIES_TO", "AND", "USES", "COMMA", "VALIDATION_FRAGMENT", "RULESET", "WHERE", "REPRESENT", "HASHAVE", "CONTEXT", "LPAREN", "RPAREN", "IF", "THEN", "ELSE", "IFF", "IMPLIES", "OR", "OF", "THAT", "IN", "EXACTLY", "AT_LEAST", "AT_MOST", "ONE", "TWO", "THREE", "FOUR", "INTEGER_NUMBER", "NO", "PRESENT", "THERE_IS", "NOT_PRESENT", "EACH", "IN_COLLECTION", "IS_IN", "IS_NOT_IN", "EQUALS", "NOT_EQUALS", "LESS", "LESS_EQ", "GREATER", "GREATER_EQ", "KIND_OF", "FOLLOWING", "COLON", "ADD", "MINUS", "TIMES", "DIV", "MOD", "OPERATOR", "PROPERTYNAME", "FROM", "TO", "WITH", "USING", "SUM_OF", "NUMBER_OF", "UNIQUE", "BY", "AS_A", "FIRST", "SINGLE_QUOTED_STRING", "BOOLEAN", "DECIMAL_NUMBER", "ORDINAL_NUMBER", "IDENTIFIER", "REPORT", "SEMI", "VT_CONDITIONAL_ACTION", "VT_COMPOUND_ACTION", "VT_FOREACH_ACTION", "VT_MACRO_APPLICATION", "VT_OPERATOR_ACTION", "VT_REMOVE_FROM_COLLECTION", "VT_VARIABLE_DECLARATION_ACTION", "MODEL", "OPERATORS", "ACTION_RULE", "ACTION_FRAGMENT", "CREATE", "NEW", "REMOVE", "SET", "ADD_VERB"
    };
    public static final int EOF=-1;
    public static final int VT_COMPOUND_REPORT=4;
    public static final int VT_CONCATENATED_REPORT=5;
    public static final int VT_CONDITIONAL_REPORT=6;
    public static final int VT_NAMED_PARAMETER=7;
    public static final int VT_ENUMERATOR=8;
    public static final int VT_EXISTS=9;
    public static final int VT_FIRST_ORDINAL_NUMBER=10;
    public static final int VT_MODELREFERENCE=11;
    public static final int VT_MULTIPLE_EXISTS=12;
    public static final int VT_MULTIPLE_NOTEXISTS=13;
    public static final int VT_NEGATE_DECIMAL=14;
    public static final int VT_NEGATE_INTEGER=15;
    public static final int VT_RULEFILE=16;
    public static final int VT_SELECTION_EXPR=17;
    public static final int VT_SINGLE_SELECTION_EXPR=18;
    public static final int VT_VARIABLE_DECLARATION=19;
    public static final int VALIDATION_RULE=20;
    public static final int DOUBLE_QUOTED_STRING=21;
    public static final int APPLIES_TO=22;
    public static final int AND=23;
    public static final int USES=24;
    public static final int COMMA=25;
    public static final int VALIDATION_FRAGMENT=26;
    public static final int RULESET=27;
    public static final int WHERE=28;
    public static final int REPRESENT=29;
    public static final int HASHAVE=30;
    public static final int CONTEXT=31;
    public static final int LPAREN=32;
    public static final int RPAREN=33;
    public static final int IF=34;
    public static final int THEN=35;
    public static final int ELSE=36;
    public static final int IFF=37;
    public static final int IMPLIES=38;
    public static final int OR=39;
    public static final int OF=40;
    public static final int THAT=41;
    public static final int IN=42;
    public static final int EXACTLY=43;
    public static final int AT_LEAST=44;
    public static final int AT_MOST=45;
    public static final int ONE=46;
    public static final int TWO=47;
    public static final int THREE=48;
    public static final int FOUR=49;
    public static final int INTEGER_NUMBER=50;
    public static final int NO=51;
    public static final int PRESENT=52;
    public static final int THERE_IS=53;
    public static final int NOT_PRESENT=54;
    public static final int EACH=55;
    public static final int IN_COLLECTION=56;
    public static final int IS_IN=57;
    public static final int IS_NOT_IN=58;
    public static final int EQUALS=59;
    public static final int NOT_EQUALS=60;
    public static final int LESS=61;
    public static final int LESS_EQ=62;
    public static final int GREATER=63;
    public static final int GREATER_EQ=64;
    public static final int KIND_OF=65;
    public static final int FOLLOWING=66;
    public static final int COLON=67;
    public static final int ADD=68;
    public static final int MINUS=69;
    public static final int TIMES=70;
    public static final int DIV=71;
    public static final int MOD=72;
    public static final int OPERATOR=73;
    public static final int PROPERTYNAME=74;
    public static final int FROM=75;
    public static final int TO=76;
    public static final int WITH=77;
    public static final int USING=78;
    public static final int SUM_OF=79;
    public static final int NUMBER_OF=80;
    public static final int UNIQUE=81;
    public static final int BY=82;
    public static final int AS_A=83;
    public static final int FIRST=84;
    public static final int SINGLE_QUOTED_STRING=85;
    public static final int BOOLEAN=86;
    public static final int DECIMAL_NUMBER=87;
    public static final int ORDINAL_NUMBER=88;
    public static final int IDENTIFIER=89;
    public static final int REPORT=90;
    public static final int SEMI=91;
    public static final int VT_CONDITIONAL_ACTION=92;
    public static final int VT_COMPOUND_ACTION=93;
    public static final int VT_FOREACH_ACTION=94;
    public static final int VT_MACRO_APPLICATION=95;
    public static final int VT_OPERATOR_ACTION=96;
    public static final int VT_REMOVE_FROM_COLLECTION=97;
    public static final int VT_VARIABLE_DECLARATION_ACTION=98;
    public static final int MODEL=99;
    public static final int OPERATORS=100;
    public static final int ACTION_RULE=101;
    public static final int ACTION_FRAGMENT=102;
    public static final int CREATE=103;
    public static final int NEW=104;
    public static final int REMOVE=105;
    public static final int SET=106;
    public static final int ADD_VERB=107;

    // delegates
    public NRLActionParser_NRLConstraintRules gNRLConstraintRules;
    // delegators


        public NRLActionParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public NRLActionParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
            gNRLConstraintRules = new NRLActionParser_NRLConstraintRules(input, state, this);         
        }
        
    protected TreeAdaptor adaptor = new CommonTreeAdaptor();

    public void setTreeAdaptor(TreeAdaptor adaptor) {
        this.adaptor = adaptor;
        gNRLConstraintRules.setTreeAdaptor(this.adaptor);
    }
    public TreeAdaptor getTreeAdaptor() {
        return adaptor;
    }

    public String[] getTokenNames() { return NRLActionParser.tokenNames; }
    public String getGrammarFileName() { return "net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g"; }


    	public java.util.List<NRLError> getSyntaxErrors() {
    		return gNRLConstraintRules.getSyntaxErrors();
    	}
    	
    	public boolean hasErrors() {
    		return gNRLConstraintRules.hasErrors();
    	}
    	
    	
    	public void resetErrors() {
    		gNRLConstraintRules.resetErrors();
    	}
    	
    	public void displayRecognitionError(String[] tokenNames, RecognitionException e) {
    		gNRLConstraintRules.displayRecognitionError(tokenNames, e);
    	}	

    	public void initialisePositionFromChild(Object obj, int index) {
    		if (obj instanceof Antlr3NRLBaseAst)
    			((Antlr3NRLBaseAst) obj).initialisePositionFromChild(index);
    	}


    public static class fileBody_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "fileBody"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:95:1: fileBody : modelFileReferences operatorFileReferences declarations EOF -> ^( VT_RULEFILE modelFileReferences ( operatorFileReferences )? ( declarations )? ) ;
    public final NRLActionParser.fileBody_return fileBody() throws RecognitionException {
        NRLActionParser.fileBody_return retval = new NRLActionParser.fileBody_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token EOF4=null;
        NRLActionParser.modelFileReferences_return modelFileReferences1 = null;

        NRLActionParser.operatorFileReferences_return operatorFileReferences2 = null;

        NRLActionParser.declarations_return declarations3 = null;


        CommonTree EOF4_tree=null;
        RewriteRuleTokenStream stream_EOF=new RewriteRuleTokenStream(adaptor,"token EOF");
        RewriteRuleSubtreeStream stream_operatorFileReferences=new RewriteRuleSubtreeStream(adaptor,"rule operatorFileReferences");
        RewriteRuleSubtreeStream stream_modelFileReferences=new RewriteRuleSubtreeStream(adaptor,"rule modelFileReferences");
        RewriteRuleSubtreeStream stream_declarations=new RewriteRuleSubtreeStream(adaptor,"rule declarations");
        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:96:3: ( modelFileReferences operatorFileReferences declarations EOF -> ^( VT_RULEFILE modelFileReferences ( operatorFileReferences )? ( declarations )? ) )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:96:5: modelFileReferences operatorFileReferences declarations EOF
            {
            pushFollow(FOLLOW_modelFileReferences_in_fileBody96);
            modelFileReferences1=modelFileReferences();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_modelFileReferences.add(modelFileReferences1.getTree());
            pushFollow(FOLLOW_operatorFileReferences_in_fileBody98);
            operatorFileReferences2=operatorFileReferences();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_operatorFileReferences.add(operatorFileReferences2.getTree());
            pushFollow(FOLLOW_declarations_in_fileBody100);
            declarations3=declarations();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_declarations.add(declarations3.getTree());
            EOF4=(Token)match(input,EOF,FOLLOW_EOF_in_fileBody102); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_EOF.add(EOF4);



            // AST REWRITE
            // elements: declarations, modelFileReferences, operatorFileReferences
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 97:4: -> ^( VT_RULEFILE modelFileReferences ( operatorFileReferences )? ( declarations )? )
            {
                // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:97:7: ^( VT_RULEFILE modelFileReferences ( operatorFileReferences )? ( declarations )? )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_RULEFILE, "VT_RULEFILE"), root_1);

                adaptor.addChild(root_1, stream_modelFileReferences.nextTree());
                // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:97:41: ( operatorFileReferences )?
                if ( stream_operatorFileReferences.hasNext() ) {
                    adaptor.addChild(root_1, stream_operatorFileReferences.nextTree());

                }
                stream_operatorFileReferences.reset();
                // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:97:65: ( declarations )?
                if ( stream_declarations.hasNext() ) {
                    adaptor.addChild(root_1, stream_declarations.nextTree());

                }
                stream_declarations.reset();

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "fileBody"

    public static class modelFileReferences_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "modelFileReferences"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:100:1: modelFileReferences : ( modelFileReference )+ ;
    public final NRLActionParser.modelFileReferences_return modelFileReferences() throws RecognitionException {
        NRLActionParser.modelFileReferences_return retval = new NRLActionParser.modelFileReferences_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NRLActionParser.modelFileReference_return modelFileReference5 = null;



        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:101:3: ( ( modelFileReference )+ )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:101:5: ( modelFileReference )+
            {
            root_0 = (CommonTree)adaptor.nil();

            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:101:5: ( modelFileReference )+
            int cnt1=0;
            loop1:
            do {
                int alt1=2;
                switch ( input.LA(1) ) {
                case MODEL:
                    {
                    alt1=1;
                    }
                    break;

                }

                switch (alt1) {
            	case 1 :
            	    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:101:6: modelFileReference
            	    {
            	    pushFollow(FOLLOW_modelFileReference_in_modelFileReferences135);
            	    modelFileReference5=modelFileReference();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, modelFileReference5.getTree());

            	    }
            	    break;

            	default :
            	    if ( cnt1 >= 1 ) break loop1;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(1, input);
                        throw eee;
                }
                cnt1++;
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "modelFileReferences"

    public static class modelFileReference_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "modelFileReference"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:104:1: modelFileReference : MODEL DOUBLE_QUOTED_STRING ;
    public final NRLActionParser.modelFileReference_return modelFileReference() throws RecognitionException {
        NRLActionParser.modelFileReference_return retval = new NRLActionParser.modelFileReference_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token MODEL6=null;
        Token DOUBLE_QUOTED_STRING7=null;

        CommonTree MODEL6_tree=null;
        CommonTree DOUBLE_QUOTED_STRING7_tree=null;

        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:105:3: ( MODEL DOUBLE_QUOTED_STRING )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:105:5: MODEL DOUBLE_QUOTED_STRING
            {
            root_0 = (CommonTree)adaptor.nil();

            MODEL6=(Token)match(input,MODEL,FOLLOW_MODEL_in_modelFileReference150); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            MODEL6_tree = (CommonTree)adaptor.create(MODEL6);
            root_0 = (CommonTree)adaptor.becomeRoot(MODEL6_tree, root_0);
            }
            DOUBLE_QUOTED_STRING7=(Token)match(input,DOUBLE_QUOTED_STRING,FOLLOW_DOUBLE_QUOTED_STRING_in_modelFileReference153); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            DOUBLE_QUOTED_STRING7_tree = (CommonTree)adaptor.create(DOUBLE_QUOTED_STRING7);
            adaptor.addChild(root_0, DOUBLE_QUOTED_STRING7_tree);
            }

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "modelFileReference"

    public static class operatorFileReferences_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "operatorFileReferences"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:108:1: operatorFileReferences : ( operatorFileReference )* ;
    public final NRLActionParser.operatorFileReferences_return operatorFileReferences() throws RecognitionException {
        NRLActionParser.operatorFileReferences_return retval = new NRLActionParser.operatorFileReferences_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NRLActionParser.operatorFileReference_return operatorFileReference8 = null;



        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:109:3: ( ( operatorFileReference )* )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:109:5: ( operatorFileReference )*
            {
            root_0 = (CommonTree)adaptor.nil();

            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:109:5: ( operatorFileReference )*
            loop2:
            do {
                int alt2=2;
                switch ( input.LA(1) ) {
                case OPERATORS:
                    {
                    alt2=1;
                    }
                    break;

                }

                switch (alt2) {
            	case 1 :
            	    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:109:6: operatorFileReference
            	    {
            	    pushFollow(FOLLOW_operatorFileReference_in_operatorFileReferences169);
            	    operatorFileReference8=operatorFileReference();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, operatorFileReference8.getTree());

            	    }
            	    break;

            	default :
            	    break loop2;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "operatorFileReferences"

    public static class operatorFileReference_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "operatorFileReference"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:112:1: operatorFileReference : OPERATORS DOUBLE_QUOTED_STRING ;
    public final NRLActionParser.operatorFileReference_return operatorFileReference() throws RecognitionException {
        NRLActionParser.operatorFileReference_return retval = new NRLActionParser.operatorFileReference_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token OPERATORS9=null;
        Token DOUBLE_QUOTED_STRING10=null;

        CommonTree OPERATORS9_tree=null;
        CommonTree DOUBLE_QUOTED_STRING10_tree=null;

        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:113:3: ( OPERATORS DOUBLE_QUOTED_STRING )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:113:5: OPERATORS DOUBLE_QUOTED_STRING
            {
            root_0 = (CommonTree)adaptor.nil();

            OPERATORS9=(Token)match(input,OPERATORS,FOLLOW_OPERATORS_in_operatorFileReference184); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            OPERATORS9_tree = (CommonTree)adaptor.create(OPERATORS9);
            root_0 = (CommonTree)adaptor.becomeRoot(OPERATORS9_tree, root_0);
            }
            DOUBLE_QUOTED_STRING10=(Token)match(input,DOUBLE_QUOTED_STRING,FOLLOW_DOUBLE_QUOTED_STRING_in_operatorFileReference187); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            DOUBLE_QUOTED_STRING10_tree = (CommonTree)adaptor.create(DOUBLE_QUOTED_STRING10);
            adaptor.addChild(root_0, DOUBLE_QUOTED_STRING10_tree);
            }

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "operatorFileReference"

    public static class declarations_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "declarations"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:116:1: declarations : ( declaration )* ;
    public final NRLActionParser.declarations_return declarations() throws RecognitionException {
        NRLActionParser.declarations_return retval = new NRLActionParser.declarations_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NRLActionParser.declaration_return declaration11 = null;



        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:117:3: ( ( declaration )* )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:117:5: ( declaration )*
            {
            root_0 = (CommonTree)adaptor.nil();

            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:117:5: ( declaration )*
            loop3:
            do {
                int alt3=2;
                switch ( input.LA(1) ) {
                case VALIDATION_RULE:
                case DOUBLE_QUOTED_STRING:
                case RULESET:
                case CONTEXT:
                case ACTION_RULE:
                    {
                    alt3=1;
                    }
                    break;

                }

                switch (alt3) {
            	case 1 :
            	    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:117:6: declaration
            	    {
            	    pushFollow(FOLLOW_declaration_in_declarations205);
            	    declaration11=declaration();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, declaration11.getTree());

            	    }
            	    break;

            	default :
            	    break loop3;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "declarations"

    public static class declaration_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "declaration"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:120:1: declaration : ( ( context VALIDATION_RULE )=> validationRuleDeclaration | ( VALIDATION_RULE )=> validationRuleDeclaration | ( actionContext ACTION_RULE )=> actionRuleDeclaration | ( ACTION_RULE )=> actionRuleDeclaration | ( multipleContext ACTION_FRAGMENT )=> actionFragmentDeclaration | globalVariableDeclaration | ruleSetDeclaration | validationFragmentDeclaration );
    public final NRLActionParser.declaration_return declaration() throws RecognitionException {
        NRLActionParser.declaration_return retval = new NRLActionParser.declaration_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NRLActionParser_NRLConstraintRules.validationRuleDeclaration_return validationRuleDeclaration12 = null;

        NRLActionParser_NRLConstraintRules.validationRuleDeclaration_return validationRuleDeclaration13 = null;

        NRLActionParser.actionRuleDeclaration_return actionRuleDeclaration14 = null;

        NRLActionParser.actionRuleDeclaration_return actionRuleDeclaration15 = null;

        NRLActionParser.actionFragmentDeclaration_return actionFragmentDeclaration16 = null;

        NRLActionParser_NRLConstraintRules.globalVariableDeclaration_return globalVariableDeclaration17 = null;

        NRLActionParser_NRLConstraintRules.ruleSetDeclaration_return ruleSetDeclaration18 = null;

        NRLActionParser_NRLConstraintRules.validationFragmentDeclaration_return validationFragmentDeclaration19 = null;



        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:121:3: ( ( context VALIDATION_RULE )=> validationRuleDeclaration | ( VALIDATION_RULE )=> validationRuleDeclaration | ( actionContext ACTION_RULE )=> actionRuleDeclaration | ( ACTION_RULE )=> actionRuleDeclaration | ( multipleContext ACTION_FRAGMENT )=> actionFragmentDeclaration | globalVariableDeclaration | ruleSetDeclaration | validationFragmentDeclaration )
            int alt4=8;
            alt4 = dfa4.predict(input);
            switch (alt4) {
                case 1 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:121:5: ( context VALIDATION_RULE )=> validationRuleDeclaration
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_validationRuleDeclaration_in_declaration229);
                    validationRuleDeclaration12=validationRuleDeclaration();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, validationRuleDeclaration12.getTree());

                    }
                    break;
                case 2 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:122:5: ( VALIDATION_RULE )=> validationRuleDeclaration
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_validationRuleDeclaration_in_declaration241);
                    validationRuleDeclaration13=validationRuleDeclaration();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, validationRuleDeclaration13.getTree());

                    }
                    break;
                case 3 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:123:5: ( actionContext ACTION_RULE )=> actionRuleDeclaration
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_actionRuleDeclaration_in_declaration255);
                    actionRuleDeclaration14=actionRuleDeclaration();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, actionRuleDeclaration14.getTree());

                    }
                    break;
                case 4 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:124:5: ( ACTION_RULE )=> actionRuleDeclaration
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_actionRuleDeclaration_in_declaration267);
                    actionRuleDeclaration15=actionRuleDeclaration();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, actionRuleDeclaration15.getTree());

                    }
                    break;
                case 5 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:125:5: ( multipleContext ACTION_FRAGMENT )=> actionFragmentDeclaration
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_actionFragmentDeclaration_in_declaration281);
                    actionFragmentDeclaration16=actionFragmentDeclaration();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, actionFragmentDeclaration16.getTree());

                    }
                    break;
                case 6 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:126:5: globalVariableDeclaration
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_globalVariableDeclaration_in_declaration287);
                    globalVariableDeclaration17=globalVariableDeclaration();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, globalVariableDeclaration17.getTree());

                    }
                    break;
                case 7 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:127:5: ruleSetDeclaration
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_ruleSetDeclaration_in_declaration293);
                    ruleSetDeclaration18=ruleSetDeclaration();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, ruleSetDeclaration18.getTree());

                    }
                    break;
                case 8 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:128:5: validationFragmentDeclaration
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_validationFragmentDeclaration_in_declaration299);
                    validationFragmentDeclaration19=validationFragmentDeclaration();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, validationFragmentDeclaration19.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "declaration"

    public static class actionRuleDeclaration_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "actionRuleDeclaration"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:133:1: actionRuleDeclaration : ( actionContext ACTION_RULE DOUBLE_QUOTED_STRING action | ACTION_RULE DOUBLE_QUOTED_STRING APPLIES_TO modelReference ( AND USES additionalContextList )? action );
    public final NRLActionParser.actionRuleDeclaration_return actionRuleDeclaration() throws RecognitionException {
        NRLActionParser.actionRuleDeclaration_return retval = new NRLActionParser.actionRuleDeclaration_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token ACTION_RULE21=null;
        Token DOUBLE_QUOTED_STRING22=null;
        Token ACTION_RULE24=null;
        Token DOUBLE_QUOTED_STRING25=null;
        Token APPLIES_TO26=null;
        Token AND28=null;
        Token USES29=null;
        NRLActionParser.actionContext_return actionContext20 = null;

        NRLActionParser.action_return action23 = null;

        NRLActionParser_NRLConstraintRules.modelReference_return modelReference27 = null;

        NRLActionParser_NRLConstraintRules.additionalContextList_return additionalContextList30 = null;

        NRLActionParser.action_return action31 = null;


        CommonTree ACTION_RULE21_tree=null;
        CommonTree DOUBLE_QUOTED_STRING22_tree=null;
        CommonTree ACTION_RULE24_tree=null;
        CommonTree DOUBLE_QUOTED_STRING25_tree=null;
        CommonTree APPLIES_TO26_tree=null;
        CommonTree AND28_tree=null;
        CommonTree USES29_tree=null;

        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:134:3: ( actionContext ACTION_RULE DOUBLE_QUOTED_STRING action | ACTION_RULE DOUBLE_QUOTED_STRING APPLIES_TO modelReference ( AND USES additionalContextList )? action )
            int alt6=2;
            switch ( input.LA(1) ) {
            case CONTEXT:
                {
                alt6=1;
                }
                break;
            case ACTION_RULE:
                {
                alt6=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 6, 0, input);

                throw nvae;
            }

            switch (alt6) {
                case 1 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:134:5: actionContext ACTION_RULE DOUBLE_QUOTED_STRING action
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_actionContext_in_actionRuleDeclaration316);
                    actionContext20=actionContext();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, actionContext20.getTree());
                    ACTION_RULE21=(Token)match(input,ACTION_RULE,FOLLOW_ACTION_RULE_in_actionRuleDeclaration318); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    ACTION_RULE21_tree = (CommonTree)adaptor.create(ACTION_RULE21);
                    root_0 = (CommonTree)adaptor.becomeRoot(ACTION_RULE21_tree, root_0);
                    }
                    DOUBLE_QUOTED_STRING22=(Token)match(input,DOUBLE_QUOTED_STRING,FOLLOW_DOUBLE_QUOTED_STRING_in_actionRuleDeclaration321); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    DOUBLE_QUOTED_STRING22_tree = (CommonTree)adaptor.create(DOUBLE_QUOTED_STRING22);
                    adaptor.addChild(root_0, DOUBLE_QUOTED_STRING22_tree);
                    }
                    pushFollow(FOLLOW_action_in_actionRuleDeclaration323);
                    action23=action();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, action23.getTree());

                    }
                    break;
                case 2 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:135:5: ACTION_RULE DOUBLE_QUOTED_STRING APPLIES_TO modelReference ( AND USES additionalContextList )? action
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    ACTION_RULE24=(Token)match(input,ACTION_RULE,FOLLOW_ACTION_RULE_in_actionRuleDeclaration329); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    ACTION_RULE24_tree = (CommonTree)adaptor.create(ACTION_RULE24);
                    root_0 = (CommonTree)adaptor.becomeRoot(ACTION_RULE24_tree, root_0);
                    }
                    DOUBLE_QUOTED_STRING25=(Token)match(input,DOUBLE_QUOTED_STRING,FOLLOW_DOUBLE_QUOTED_STRING_in_actionRuleDeclaration332); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    DOUBLE_QUOTED_STRING25_tree = (CommonTree)adaptor.create(DOUBLE_QUOTED_STRING25);
                    adaptor.addChild(root_0, DOUBLE_QUOTED_STRING25_tree);
                    }
                    APPLIES_TO26=(Token)match(input,APPLIES_TO,FOLLOW_APPLIES_TO_in_actionRuleDeclaration334); if (state.failed) return retval;
                    pushFollow(FOLLOW_modelReference_in_actionRuleDeclaration337);
                    modelReference27=modelReference();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference27.getTree());
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:135:66: ( AND USES additionalContextList )?
                    int alt5=2;
                    switch ( input.LA(1) ) {
                        case AND:
                            {
                            alt5=1;
                            }
                            break;
                    }

                    switch (alt5) {
                        case 1 :
                            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:135:68: AND USES additionalContextList
                            {
                            AND28=(Token)match(input,AND,FOLLOW_AND_in_actionRuleDeclaration341); if (state.failed) return retval;
                            USES29=(Token)match(input,USES,FOLLOW_USES_in_actionRuleDeclaration344); if (state.failed) return retval;
                            pushFollow(FOLLOW_additionalContextList_in_actionRuleDeclaration347);
                            additionalContextList30=additionalContextList();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) adaptor.addChild(root_0, additionalContextList30.getTree());

                            }
                            break;

                    }

                    pushFollow(FOLLOW_action_in_actionRuleDeclaration352);
                    action31=action();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, action31.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "actionRuleDeclaration"

    public static class actionFragmentDeclaration_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "actionFragmentDeclaration"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:138:1: actionFragmentDeclaration : multipleContext ACTION_FRAGMENT DOUBLE_QUOTED_STRING action ;
    public final NRLActionParser.actionFragmentDeclaration_return actionFragmentDeclaration() throws RecognitionException {
        NRLActionParser.actionFragmentDeclaration_return retval = new NRLActionParser.actionFragmentDeclaration_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token ACTION_FRAGMENT33=null;
        Token DOUBLE_QUOTED_STRING34=null;
        NRLActionParser_NRLConstraintRules.multipleContext_return multipleContext32 = null;

        NRLActionParser.action_return action35 = null;


        CommonTree ACTION_FRAGMENT33_tree=null;
        CommonTree DOUBLE_QUOTED_STRING34_tree=null;

        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:139:3: ( multipleContext ACTION_FRAGMENT DOUBLE_QUOTED_STRING action )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:139:5: multipleContext ACTION_FRAGMENT DOUBLE_QUOTED_STRING action
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_multipleContext_in_actionFragmentDeclaration367);
            multipleContext32=multipleContext();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, multipleContext32.getTree());
            ACTION_FRAGMENT33=(Token)match(input,ACTION_FRAGMENT,FOLLOW_ACTION_FRAGMENT_in_actionFragmentDeclaration369); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            ACTION_FRAGMENT33_tree = (CommonTree)adaptor.create(ACTION_FRAGMENT33);
            root_0 = (CommonTree)adaptor.becomeRoot(ACTION_FRAGMENT33_tree, root_0);
            }
            DOUBLE_QUOTED_STRING34=(Token)match(input,DOUBLE_QUOTED_STRING,FOLLOW_DOUBLE_QUOTED_STRING_in_actionFragmentDeclaration372); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            DOUBLE_QUOTED_STRING34_tree = (CommonTree)adaptor.create(DOUBLE_QUOTED_STRING34);
            adaptor.addChild(root_0, DOUBLE_QUOTED_STRING34_tree);
            }
            pushFollow(FOLLOW_action_in_actionFragmentDeclaration374);
            action35=action();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, action35.getTree());

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "actionFragmentDeclaration"

    public static class actionContext_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "actionContext"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:142:1: actionContext : ( CONTEXT modelReference | CONTEXT NO );
    public final NRLActionParser.actionContext_return actionContext() throws RecognitionException {
        NRLActionParser.actionContext_return retval = new NRLActionParser.actionContext_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token CONTEXT36=null;
        Token CONTEXT38=null;
        Token NO39=null;
        NRLActionParser_NRLConstraintRules.modelReference_return modelReference37 = null;


        CommonTree CONTEXT36_tree=null;
        CommonTree CONTEXT38_tree=null;
        CommonTree NO39_tree=null;

        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:143:3: ( CONTEXT modelReference | CONTEXT NO )
            int alt7=2;
            switch ( input.LA(1) ) {
            case CONTEXT:
                {
                switch ( input.LA(2) ) {
                case NO:
                    {
                    alt7=2;
                    }
                    break;
                case IDENTIFIER:
                    {
                    alt7=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 7, 1, input);

                    throw nvae;
                }

                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 7, 0, input);

                throw nvae;
            }

            switch (alt7) {
                case 1 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:143:5: CONTEXT modelReference
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    CONTEXT36=(Token)match(input,CONTEXT,FOLLOW_CONTEXT_in_actionContext387); if (state.failed) return retval;
                    pushFollow(FOLLOW_modelReference_in_actionContext390);
                    modelReference37=modelReference();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference37.getTree());

                    }
                    break;
                case 2 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:144:5: CONTEXT NO
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    CONTEXT38=(Token)match(input,CONTEXT,FOLLOW_CONTEXT_in_actionContext396); if (state.failed) return retval;
                    NO39=(Token)match(input,NO,FOLLOW_NO_in_actionContext399); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    NO39_tree = (CommonTree)adaptor.create(NO39);
                    adaptor.addChild(root_0, NO39_tree);
                    }

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "actionContext"

    public static class singleActionAndEOF_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "singleActionAndEOF"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:147:1: singleActionAndEOF : action EOF ;
    public final NRLActionParser.singleActionAndEOF_return singleActionAndEOF() throws RecognitionException {
        NRLActionParser.singleActionAndEOF_return retval = new NRLActionParser.singleActionAndEOF_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token EOF41=null;
        NRLActionParser.action_return action40 = null;


        CommonTree EOF41_tree=null;

        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:148:3: ( action EOF )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:148:5: action EOF
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_action_in_singleActionAndEOF413);
            action40=action();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, action40.getTree());
            EOF41=(Token)match(input,EOF,FOLLOW_EOF_in_singleActionAndEOF415); if (state.failed) return retval;

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "singleActionAndEOF"

    public static class action_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "action"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:151:1: action : compoundAction ;
    public final NRLActionParser.action_return action() throws RecognitionException {
        NRLActionParser.action_return retval = new NRLActionParser.action_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NRLActionParser.compoundAction_return compoundAction42 = null;



        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:152:3: ( compoundAction )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:152:5: compoundAction
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_compoundAction_in_action431);
            compoundAction42=compoundAction();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, compoundAction42.getTree());

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "action"

    public static class conditionalAction_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "conditionalAction"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:155:1: conditionalAction : IF cif= statement THEN cthen= action ( options {greedy=true; } : ELSE celse= action )? SEMI -> ^( VT_CONDITIONAL_ACTION $cif $cthen ( $celse)? ) ;
    public final NRLActionParser.conditionalAction_return conditionalAction() throws RecognitionException {
        NRLActionParser.conditionalAction_return retval = new NRLActionParser.conditionalAction_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token IF43=null;
        Token THEN44=null;
        Token ELSE45=null;
        Token SEMI46=null;
        NRLActionParser_NRLConstraintRules.statement_return cif = null;

        NRLActionParser.action_return cthen = null;

        NRLActionParser.action_return celse = null;


        CommonTree IF43_tree=null;
        CommonTree THEN44_tree=null;
        CommonTree ELSE45_tree=null;
        CommonTree SEMI46_tree=null;
        RewriteRuleTokenStream stream_THEN=new RewriteRuleTokenStream(adaptor,"token THEN");
        RewriteRuleTokenStream stream_SEMI=new RewriteRuleTokenStream(adaptor,"token SEMI");
        RewriteRuleTokenStream stream_IF=new RewriteRuleTokenStream(adaptor,"token IF");
        RewriteRuleTokenStream stream_ELSE=new RewriteRuleTokenStream(adaptor,"token ELSE");
        RewriteRuleSubtreeStream stream_statement=new RewriteRuleSubtreeStream(adaptor,"rule statement");
        RewriteRuleSubtreeStream stream_action=new RewriteRuleSubtreeStream(adaptor,"rule action");
        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:157:3: ( IF cif= statement THEN cthen= action ( options {greedy=true; } : ELSE celse= action )? SEMI -> ^( VT_CONDITIONAL_ACTION $cif $cthen ( $celse)? ) )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:157:5: IF cif= statement THEN cthen= action ( options {greedy=true; } : ELSE celse= action )? SEMI
            {
            IF43=(Token)match(input,IF,FOLLOW_IF_in_conditionalAction451); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_IF.add(IF43);

            pushFollow(FOLLOW_statement_in_conditionalAction455);
            cif=statement();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_statement.add(cif.getTree());
            THEN44=(Token)match(input,THEN,FOLLOW_THEN_in_conditionalAction457); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_THEN.add(THEN44);

            pushFollow(FOLLOW_action_in_conditionalAction461);
            cthen=action();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_action.add(cthen.getTree());
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:158:4: ( options {greedy=true; } : ELSE celse= action )?
            int alt8=2;
            switch ( input.LA(1) ) {
                case ELSE:
                    {
                    alt8=1;
                    }
                    break;
            }

            switch (alt8) {
                case 1 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:162:5: ELSE celse= action
                    {
                    ELSE45=(Token)match(input,ELSE,FOLLOW_ELSE_in_conditionalAction498); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_ELSE.add(ELSE45);

                    pushFollow(FOLLOW_action_in_conditionalAction502);
                    celse=action();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_action.add(celse.getTree());

                    }
                    break;

            }

            SEMI46=(Token)match(input,SEMI,FOLLOW_SEMI_in_conditionalAction513); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_SEMI.add(SEMI46);



            // AST REWRITE
            // elements: celse, cif, cthen
            // token labels: 
            // rule labels: retval, cif, celse, cthen
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_cif=new RewriteRuleSubtreeStream(adaptor,"rule cif",cif!=null?cif.tree:null);
            RewriteRuleSubtreeStream stream_celse=new RewriteRuleSubtreeStream(adaptor,"rule celse",celse!=null?celse.tree:null);
            RewriteRuleSubtreeStream stream_cthen=new RewriteRuleSubtreeStream(adaptor,"rule cthen",cthen!=null?cthen.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 165:4: -> ^( VT_CONDITIONAL_ACTION $cif $cthen ( $celse)? )
            {
                // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:165:7: ^( VT_CONDITIONAL_ACTION $cif $cthen ( $celse)? )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_CONDITIONAL_ACTION, "VT_CONDITIONAL_ACTION"), root_1);

                adaptor.addChild(root_1, stream_cif.nextTree());
                adaptor.addChild(root_1, stream_cthen.nextTree());
                // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:165:43: ( $celse)?
                if ( stream_celse.hasNext() ) {
                    adaptor.addChild(root_1, stream_celse.nextTree());

                }
                stream_celse.reset();

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
            if ( state.backtracking==0 ) {
               initialisePositionFromChild(retval.tree, 0); 
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "conditionalAction"

    public static class compoundAction_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "compoundAction"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:168:1: compoundAction : simpleActionList -> ^( VT_COMPOUND_ACTION simpleActionList ) ;
    public final NRLActionParser.compoundAction_return compoundAction() throws RecognitionException {
        NRLActionParser.compoundAction_return retval = new NRLActionParser.compoundAction_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NRLActionParser.simpleActionList_return simpleActionList47 = null;


        RewriteRuleSubtreeStream stream_simpleActionList=new RewriteRuleSubtreeStream(adaptor,"rule simpleActionList");
        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:170:3: ( simpleActionList -> ^( VT_COMPOUND_ACTION simpleActionList ) )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:170:5: simpleActionList
            {
            pushFollow(FOLLOW_simpleActionList_in_compoundAction550);
            simpleActionList47=simpleActionList();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_simpleActionList.add(simpleActionList47.getTree());


            // AST REWRITE
            // elements: simpleActionList
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 171:4: -> ^( VT_COMPOUND_ACTION simpleActionList )
            {
                // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:171:7: ^( VT_COMPOUND_ACTION simpleActionList )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_COMPOUND_ACTION, "VT_COMPOUND_ACTION"), root_1);

                adaptor.addChild(root_1, stream_simpleActionList.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
            if ( state.backtracking==0 ) {
               initialisePositionFromChild(retval.tree, 0); 
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "compoundAction"

    public static class simpleActionList_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "simpleActionList"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:174:1: simpleActionList : simpleAction ( ( COMMA )? ( THEN )? simpleAction )* ;
    public final NRLActionParser.simpleActionList_return simpleActionList() throws RecognitionException {
        NRLActionParser.simpleActionList_return retval = new NRLActionParser.simpleActionList_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token COMMA49=null;
        Token THEN50=null;
        NRLActionParser.simpleAction_return simpleAction48 = null;

        NRLActionParser.simpleAction_return simpleAction51 = null;


        CommonTree COMMA49_tree=null;
        CommonTree THEN50_tree=null;

        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:175:3: ( simpleAction ( ( COMMA )? ( THEN )? simpleAction )* )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:175:5: simpleAction ( ( COMMA )? ( THEN )? simpleAction )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_simpleAction_in_simpleActionList576);
            simpleAction48=simpleAction();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, simpleAction48.getTree());
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:175:18: ( ( COMMA )? ( THEN )? simpleAction )*
            loop11:
            do {
                int alt11=2;
                alt11 = dfa11.predict(input);
                switch (alt11) {
            	case 1 :
            	    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:175:20: ( COMMA )? ( THEN )? simpleAction
            	    {
            	    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:175:20: ( COMMA )?
            	    int alt9=2;
            	    switch ( input.LA(1) ) {
            	        case COMMA:
            	            {
            	            alt9=1;
            	            }
            	            break;
            	    }

            	    switch (alt9) {
            	        case 1 :
            	            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:175:21: COMMA
            	            {
            	            COMMA49=(Token)match(input,COMMA,FOLLOW_COMMA_in_simpleActionList581); if (state.failed) return retval;

            	            }
            	            break;

            	    }

            	    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:175:30: ( THEN )?
            	    int alt10=2;
            	    switch ( input.LA(1) ) {
            	        case THEN:
            	            {
            	            alt10=1;
            	            }
            	            break;
            	    }

            	    switch (alt10) {
            	        case 1 :
            	            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:175:31: THEN
            	            {
            	            THEN50=(Token)match(input,THEN,FOLLOW_THEN_in_simpleActionList587); if (state.failed) return retval;

            	            }
            	            break;

            	    }

            	    pushFollow(FOLLOW_simpleAction_in_simpleActionList592);
            	    simpleAction51=simpleAction();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, simpleAction51.getTree());

            	    }
            	    break;

            	default :
            	    break loop11;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "simpleActionList"

    public static class simpleAction_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "simpleAction"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:178:1: simpleAction : ( createAction | ( REMOVE modelReference FROM )=> removeFromCollectionAction | removeAction | setAction | addAction | operatorAction | macroApplicationAction | forEachAction | variableDeclarationAction | conditionalAction );
    public final NRLActionParser.simpleAction_return simpleAction() throws RecognitionException {
        NRLActionParser.simpleAction_return retval = new NRLActionParser.simpleAction_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NRLActionParser.createAction_return createAction52 = null;

        NRLActionParser.removeFromCollectionAction_return removeFromCollectionAction53 = null;

        NRLActionParser.removeAction_return removeAction54 = null;

        NRLActionParser.setAction_return setAction55 = null;

        NRLActionParser.addAction_return addAction56 = null;

        NRLActionParser.operatorAction_return operatorAction57 = null;

        NRLActionParser.macroApplicationAction_return macroApplicationAction58 = null;

        NRLActionParser.forEachAction_return forEachAction59 = null;

        NRLActionParser.variableDeclarationAction_return variableDeclarationAction60 = null;

        NRLActionParser.conditionalAction_return conditionalAction61 = null;



        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:179:3: ( createAction | ( REMOVE modelReference FROM )=> removeFromCollectionAction | removeAction | setAction | addAction | operatorAction | macroApplicationAction | forEachAction | variableDeclarationAction | conditionalAction )
            int alt12=10;
            alt12 = dfa12.predict(input);
            switch (alt12) {
                case 1 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:179:5: createAction
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_createAction_in_simpleAction610);
                    createAction52=createAction();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, createAction52.getTree());

                    }
                    break;
                case 2 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:180:5: ( REMOVE modelReference FROM )=> removeFromCollectionAction
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_removeFromCollectionAction_in_simpleAction626);
                    removeFromCollectionAction53=removeFromCollectionAction();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, removeFromCollectionAction53.getTree());

                    }
                    break;
                case 3 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:181:5: removeAction
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_removeAction_in_simpleAction632);
                    removeAction54=removeAction();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, removeAction54.getTree());

                    }
                    break;
                case 4 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:182:5: setAction
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_setAction_in_simpleAction638);
                    setAction55=setAction();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, setAction55.getTree());

                    }
                    break;
                case 5 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:183:5: addAction
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_addAction_in_simpleAction644);
                    addAction56=addAction();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, addAction56.getTree());

                    }
                    break;
                case 6 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:184:5: operatorAction
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_operatorAction_in_simpleAction650);
                    operatorAction57=operatorAction();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, operatorAction57.getTree());

                    }
                    break;
                case 7 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:185:5: macroApplicationAction
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_macroApplicationAction_in_simpleAction656);
                    macroApplicationAction58=macroApplicationAction();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, macroApplicationAction58.getTree());

                    }
                    break;
                case 8 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:186:5: forEachAction
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_forEachAction_in_simpleAction662);
                    forEachAction59=forEachAction();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, forEachAction59.getTree());

                    }
                    break;
                case 9 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:187:5: variableDeclarationAction
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_variableDeclarationAction_in_simpleAction668);
                    variableDeclarationAction60=variableDeclarationAction();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, variableDeclarationAction60.getTree());

                    }
                    break;
                case 10 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:188:5: conditionalAction
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_conditionalAction_in_simpleAction674);
                    conditionalAction61=conditionalAction();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, conditionalAction61.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "simpleAction"

    public static class createAction_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "createAction"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:191:1: createAction : CREATE NEW modelReference ( LPAREN var= DOUBLE_QUOTED_STRING RPAREN )? ;
    public final NRLActionParser.createAction_return createAction() throws RecognitionException {
        NRLActionParser.createAction_return retval = new NRLActionParser.createAction_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token var=null;
        Token CREATE62=null;
        Token NEW63=null;
        Token LPAREN65=null;
        Token RPAREN66=null;
        NRLActionParser_NRLConstraintRules.modelReference_return modelReference64 = null;


        CommonTree var_tree=null;
        CommonTree CREATE62_tree=null;
        CommonTree NEW63_tree=null;
        CommonTree LPAREN65_tree=null;
        CommonTree RPAREN66_tree=null;

        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:192:3: ( CREATE NEW modelReference ( LPAREN var= DOUBLE_QUOTED_STRING RPAREN )? )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:192:5: CREATE NEW modelReference ( LPAREN var= DOUBLE_QUOTED_STRING RPAREN )?
            {
            root_0 = (CommonTree)adaptor.nil();

            CREATE62=(Token)match(input,CREATE,FOLLOW_CREATE_in_createAction690); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            CREATE62_tree = (CommonTree)adaptor.create(CREATE62);
            root_0 = (CommonTree)adaptor.becomeRoot(CREATE62_tree, root_0);
            }
            NEW63=(Token)match(input,NEW,FOLLOW_NEW_in_createAction693); if (state.failed) return retval;
            pushFollow(FOLLOW_modelReference_in_createAction696);
            modelReference64=modelReference();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference64.getTree());
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:192:33: ( LPAREN var= DOUBLE_QUOTED_STRING RPAREN )?
            int alt13=2;
            switch ( input.LA(1) ) {
                case LPAREN:
                    {
                    alt13=1;
                    }
                    break;
            }

            switch (alt13) {
                case 1 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:192:34: LPAREN var= DOUBLE_QUOTED_STRING RPAREN
                    {
                    LPAREN65=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_createAction699); if (state.failed) return retval;
                    var=(Token)match(input,DOUBLE_QUOTED_STRING,FOLLOW_DOUBLE_QUOTED_STRING_in_createAction704); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    var_tree = (CommonTree)adaptor.create(var);
                    adaptor.addChild(root_0, var_tree);
                    }
                    RPAREN66=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_createAction706); if (state.failed) return retval;

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "createAction"

    public static class removeAction_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "removeAction"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:195:1: removeAction : REMOVE ( EACH )? ( OF )? modelReference ( LPAREN var= DOUBLE_QUOTED_STRING RPAREN WHERE constraint )? ;
    public final NRLActionParser.removeAction_return removeAction() throws RecognitionException {
        NRLActionParser.removeAction_return retval = new NRLActionParser.removeAction_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token var=null;
        Token REMOVE67=null;
        Token EACH68=null;
        Token OF69=null;
        Token LPAREN71=null;
        Token RPAREN72=null;
        Token WHERE73=null;
        NRLActionParser_NRLConstraintRules.modelReference_return modelReference70 = null;

        NRLActionParser_NRLConstraintRules.constraint_return constraint74 = null;


        CommonTree var_tree=null;
        CommonTree REMOVE67_tree=null;
        CommonTree EACH68_tree=null;
        CommonTree OF69_tree=null;
        CommonTree LPAREN71_tree=null;
        CommonTree RPAREN72_tree=null;
        CommonTree WHERE73_tree=null;

        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:196:3: ( REMOVE ( EACH )? ( OF )? modelReference ( LPAREN var= DOUBLE_QUOTED_STRING RPAREN WHERE constraint )? )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:196:5: REMOVE ( EACH )? ( OF )? modelReference ( LPAREN var= DOUBLE_QUOTED_STRING RPAREN WHERE constraint )?
            {
            root_0 = (CommonTree)adaptor.nil();

            REMOVE67=(Token)match(input,REMOVE,FOLLOW_REMOVE_in_removeAction724); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            REMOVE67_tree = (CommonTree)adaptor.create(REMOVE67);
            root_0 = (CommonTree)adaptor.becomeRoot(REMOVE67_tree, root_0);
            }
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:196:13: ( EACH )?
            int alt14=2;
            switch ( input.LA(1) ) {
                case EACH:
                    {
                    alt14=1;
                    }
                    break;
            }

            switch (alt14) {
                case 1 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:196:14: EACH
                    {
                    EACH68=(Token)match(input,EACH,FOLLOW_EACH_in_removeAction728); if (state.failed) return retval;

                    }
                    break;

            }

            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:196:22: ( OF )?
            int alt15=2;
            switch ( input.LA(1) ) {
                case OF:
                    {
                    alt15=1;
                    }
                    break;
            }

            switch (alt15) {
                case 1 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:196:23: OF
                    {
                    OF69=(Token)match(input,OF,FOLLOW_OF_in_removeAction734); if (state.failed) return retval;

                    }
                    break;

            }

            pushFollow(FOLLOW_modelReference_in_removeAction739);
            modelReference70=modelReference();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference70.getTree());
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:196:44: ( LPAREN var= DOUBLE_QUOTED_STRING RPAREN WHERE constraint )?
            int alt16=2;
            switch ( input.LA(1) ) {
                case LPAREN:
                    {
                    alt16=1;
                    }
                    break;
            }

            switch (alt16) {
                case 1 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:196:45: LPAREN var= DOUBLE_QUOTED_STRING RPAREN WHERE constraint
                    {
                    LPAREN71=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_removeAction742); if (state.failed) return retval;
                    var=(Token)match(input,DOUBLE_QUOTED_STRING,FOLLOW_DOUBLE_QUOTED_STRING_in_removeAction747); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    var_tree = (CommonTree)adaptor.create(var);
                    adaptor.addChild(root_0, var_tree);
                    }
                    RPAREN72=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_removeAction749); if (state.failed) return retval;
                    WHERE73=(Token)match(input,WHERE,FOLLOW_WHERE_in_removeAction752); if (state.failed) return retval;
                    pushFollow(FOLLOW_constraint_in_removeAction755);
                    constraint74=constraint();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, constraint74.getTree());

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "removeAction"

    public static class removeFromCollectionAction_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "removeFromCollectionAction"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:199:1: removeFromCollectionAction : REMOVE source= modelReference FROM target= modelReference -> ^( VT_REMOVE_FROM_COLLECTION $source $target) ;
    public final NRLActionParser.removeFromCollectionAction_return removeFromCollectionAction() throws RecognitionException {
        NRLActionParser.removeFromCollectionAction_return retval = new NRLActionParser.removeFromCollectionAction_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token REMOVE75=null;
        Token FROM76=null;
        NRLActionParser_NRLConstraintRules.modelReference_return source = null;

        NRLActionParser_NRLConstraintRules.modelReference_return target = null;


        CommonTree REMOVE75_tree=null;
        CommonTree FROM76_tree=null;
        RewriteRuleTokenStream stream_FROM=new RewriteRuleTokenStream(adaptor,"token FROM");
        RewriteRuleTokenStream stream_REMOVE=new RewriteRuleTokenStream(adaptor,"token REMOVE");
        RewriteRuleSubtreeStream stream_modelReference=new RewriteRuleSubtreeStream(adaptor,"rule modelReference");
        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:201:3: ( REMOVE source= modelReference FROM target= modelReference -> ^( VT_REMOVE_FROM_COLLECTION $source $target) )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:201:5: REMOVE source= modelReference FROM target= modelReference
            {
            REMOVE75=(Token)match(input,REMOVE,FOLLOW_REMOVE_in_removeFromCollectionAction777); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_REMOVE.add(REMOVE75);

            pushFollow(FOLLOW_modelReference_in_removeFromCollectionAction781);
            source=modelReference();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_modelReference.add(source.getTree());
            FROM76=(Token)match(input,FROM,FOLLOW_FROM_in_removeFromCollectionAction783); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_FROM.add(FROM76);

            pushFollow(FOLLOW_modelReference_in_removeFromCollectionAction787);
            target=modelReference();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_modelReference.add(target.getTree());


            // AST REWRITE
            // elements: target, source
            // token labels: 
            // rule labels: retval, source, target
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_source=new RewriteRuleSubtreeStream(adaptor,"rule source",source!=null?source.tree:null);
            RewriteRuleSubtreeStream stream_target=new RewriteRuleSubtreeStream(adaptor,"rule target",target!=null?target.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 202:4: -> ^( VT_REMOVE_FROM_COLLECTION $source $target)
            {
                // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:202:7: ^( VT_REMOVE_FROM_COLLECTION $source $target)
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_REMOVE_FROM_COLLECTION, "VT_REMOVE_FROM_COLLECTION"), root_1);

                adaptor.addChild(root_1, stream_source.nextTree());
                adaptor.addChild(root_1, stream_target.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
            if ( state.backtracking==0 ) {
               initialisePositionFromChild(retval.tree, 0); 
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "removeFromCollectionAction"

    public static class setAction_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "setAction"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:205:1: setAction : SET modelReference TO expression ;
    public final NRLActionParser.setAction_return setAction() throws RecognitionException {
        NRLActionParser.setAction_return retval = new NRLActionParser.setAction_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token SET77=null;
        Token TO79=null;
        NRLActionParser_NRLConstraintRules.modelReference_return modelReference78 = null;

        NRLActionParser_NRLConstraintRules.expression_return expression80 = null;


        CommonTree SET77_tree=null;
        CommonTree TO79_tree=null;

        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:206:3: ( SET modelReference TO expression )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:206:5: SET modelReference TO expression
            {
            root_0 = (CommonTree)adaptor.nil();

            SET77=(Token)match(input,SET,FOLLOW_SET_in_setAction817); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            SET77_tree = (CommonTree)adaptor.create(SET77);
            root_0 = (CommonTree)adaptor.becomeRoot(SET77_tree, root_0);
            }
            pushFollow(FOLLOW_modelReference_in_setAction820);
            modelReference78=modelReference();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference78.getTree());
            TO79=(Token)match(input,TO,FOLLOW_TO_in_setAction822); if (state.failed) return retval;
            pushFollow(FOLLOW_expression_in_setAction825);
            expression80=expression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, expression80.getTree());

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "setAction"

    public static class addAction_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "addAction"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:209:1: addAction : ADD_VERB modelReference TO modelReference ;
    public final NRLActionParser.addAction_return addAction() throws RecognitionException {
        NRLActionParser.addAction_return retval = new NRLActionParser.addAction_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token ADD_VERB81=null;
        Token TO83=null;
        NRLActionParser_NRLConstraintRules.modelReference_return modelReference82 = null;

        NRLActionParser_NRLConstraintRules.modelReference_return modelReference84 = null;


        CommonTree ADD_VERB81_tree=null;
        CommonTree TO83_tree=null;

        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:210:3: ( ADD_VERB modelReference TO modelReference )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:210:5: ADD_VERB modelReference TO modelReference
            {
            root_0 = (CommonTree)adaptor.nil();

            ADD_VERB81=(Token)match(input,ADD_VERB,FOLLOW_ADD_VERB_in_addAction840); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            ADD_VERB81_tree = (CommonTree)adaptor.create(ADD_VERB81);
            root_0 = (CommonTree)adaptor.becomeRoot(ADD_VERB81_tree, root_0);
            }
            pushFollow(FOLLOW_modelReference_in_addAction843);
            modelReference82=modelReference();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference82.getTree());
            TO83=(Token)match(input,TO,FOLLOW_TO_in_addAction845); if (state.failed) return retval;
            pushFollow(FOLLOW_modelReference_in_addAction848);
            modelReference84=modelReference();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference84.getTree());

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "addAction"

    public static class macroApplicationAction_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "macroApplicationAction"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:213:1: macroApplicationAction : id= PROPERTYNAME params= macroApplicationParams -> ^( VT_MACRO_APPLICATION $id $params) ;
    public final NRLActionParser.macroApplicationAction_return macroApplicationAction() throws RecognitionException {
        NRLActionParser.macroApplicationAction_return retval = new NRLActionParser.macroApplicationAction_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token id=null;
        NRLActionParser.macroApplicationParams_return params = null;


        CommonTree id_tree=null;
        RewriteRuleTokenStream stream_PROPERTYNAME=new RewriteRuleTokenStream(adaptor,"token PROPERTYNAME");
        RewriteRuleSubtreeStream stream_macroApplicationParams=new RewriteRuleSubtreeStream(adaptor,"rule macroApplicationParams");
        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:215:3: (id= PROPERTYNAME params= macroApplicationParams -> ^( VT_MACRO_APPLICATION $id $params) )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:215:5: id= PROPERTYNAME params= macroApplicationParams
            {
            id=(Token)match(input,PROPERTYNAME,FOLLOW_PROPERTYNAME_in_macroApplicationAction870); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_PROPERTYNAME.add(id);

            pushFollow(FOLLOW_macroApplicationParams_in_macroApplicationAction874);
            params=macroApplicationParams();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_macroApplicationParams.add(params.getTree());


            // AST REWRITE
            // elements: id, params
            // token labels: id
            // rule labels: retval, params
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleTokenStream stream_id=new RewriteRuleTokenStream(adaptor,"token id",id);
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_params=new RewriteRuleSubtreeStream(adaptor,"rule params",params!=null?params.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 216:4: -> ^( VT_MACRO_APPLICATION $id $params)
            {
                // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:216:7: ^( VT_MACRO_APPLICATION $id $params)
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_MACRO_APPLICATION, "VT_MACRO_APPLICATION"), root_1);

                adaptor.addChild(root_1, stream_id.nextNode());
                adaptor.addChild(root_1, stream_params.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
            if ( state.backtracking==0 ) {
               initialisePositionFromChild(retval.tree, 0); 
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "macroApplicationAction"

    public static class macroApplicationParams_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "macroApplicationParams"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:219:1: macroApplicationParams : expression ( ( AND | FROM | TO | WITH | USING ) expression )* ;
    public final NRLActionParser.macroApplicationParams_return macroApplicationParams() throws RecognitionException {
        NRLActionParser.macroApplicationParams_return retval = new NRLActionParser.macroApplicationParams_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token AND86=null;
        Token FROM87=null;
        Token TO88=null;
        Token WITH89=null;
        Token USING90=null;
        NRLActionParser_NRLConstraintRules.expression_return expression85 = null;

        NRLActionParser_NRLConstraintRules.expression_return expression91 = null;


        CommonTree AND86_tree=null;
        CommonTree FROM87_tree=null;
        CommonTree TO88_tree=null;
        CommonTree WITH89_tree=null;
        CommonTree USING90_tree=null;

        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:220:3: ( expression ( ( AND | FROM | TO | WITH | USING ) expression )* )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:220:5: expression ( ( AND | FROM | TO | WITH | USING ) expression )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_expression_in_macroApplicationParams904);
            expression85=expression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, expression85.getTree());
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:220:16: ( ( AND | FROM | TO | WITH | USING ) expression )*
            loop18:
            do {
                int alt18=2;
                switch ( input.LA(1) ) {
                case AND:
                case FROM:
                case TO:
                case WITH:
                case USING:
                    {
                    alt18=1;
                    }
                    break;

                }

                switch (alt18) {
            	case 1 :
            	    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:220:18: ( AND | FROM | TO | WITH | USING ) expression
            	    {
            	    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:220:18: ( AND | FROM | TO | WITH | USING )
            	    int alt17=5;
            	    switch ( input.LA(1) ) {
            	    case AND:
            	        {
            	        alt17=1;
            	        }
            	        break;
            	    case FROM:
            	        {
            	        alt17=2;
            	        }
            	        break;
            	    case TO:
            	        {
            	        alt17=3;
            	        }
            	        break;
            	    case WITH:
            	        {
            	        alt17=4;
            	        }
            	        break;
            	    case USING:
            	        {
            	        alt17=5;
            	        }
            	        break;
            	    default:
            	        if (state.backtracking>0) {state.failed=true; return retval;}
            	        NoViableAltException nvae =
            	            new NoViableAltException("", 17, 0, input);

            	        throw nvae;
            	    }

            	    switch (alt17) {
            	        case 1 :
            	            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:220:19: AND
            	            {
            	            AND86=(Token)match(input,AND,FOLLOW_AND_in_macroApplicationParams909); if (state.failed) return retval;

            	            }
            	            break;
            	        case 2 :
            	            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:220:24: FROM
            	            {
            	            FROM87=(Token)match(input,FROM,FOLLOW_FROM_in_macroApplicationParams912); if (state.failed) return retval;

            	            }
            	            break;
            	        case 3 :
            	            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:220:30: TO
            	            {
            	            TO88=(Token)match(input,TO,FOLLOW_TO_in_macroApplicationParams915); if (state.failed) return retval;

            	            }
            	            break;
            	        case 4 :
            	            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:220:34: WITH
            	            {
            	            WITH89=(Token)match(input,WITH,FOLLOW_WITH_in_macroApplicationParams918); if (state.failed) return retval;

            	            }
            	            break;
            	        case 5 :
            	            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:220:40: USING
            	            {
            	            USING90=(Token)match(input,USING,FOLLOW_USING_in_macroApplicationParams921); if (state.failed) return retval;

            	            }
            	            break;

            	    }

            	    pushFollow(FOLLOW_expression_in_macroApplicationParams925);
            	    expression91=expression();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, expression91.getTree());

            	    }
            	    break;

            	default :
            	    break loop18;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "macroApplicationParams"

    public static class operatorAction_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "operatorAction"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:223:1: operatorAction : OPERATOR ( operatorActionParams )? -> ^( VT_OPERATOR_ACTION OPERATOR ( operatorActionParams )? ) ;
    public final NRLActionParser.operatorAction_return operatorAction() throws RecognitionException {
        NRLActionParser.operatorAction_return retval = new NRLActionParser.operatorAction_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token OPERATOR92=null;
        NRLActionParser.operatorActionParams_return operatorActionParams93 = null;


        CommonTree OPERATOR92_tree=null;
        RewriteRuleTokenStream stream_OPERATOR=new RewriteRuleTokenStream(adaptor,"token OPERATOR");
        RewriteRuleSubtreeStream stream_operatorActionParams=new RewriteRuleSubtreeStream(adaptor,"rule operatorActionParams");
        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:225:3: ( OPERATOR ( operatorActionParams )? -> ^( VT_OPERATOR_ACTION OPERATOR ( operatorActionParams )? ) )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:225:5: OPERATOR ( operatorActionParams )?
            {
            OPERATOR92=(Token)match(input,OPERATOR,FOLLOW_OPERATOR_in_operatorAction948); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_OPERATOR.add(OPERATOR92);

            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:225:14: ( operatorActionParams )?
            int alt19=2;
            alt19 = dfa19.predict(input);
            switch (alt19) {
                case 1 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:225:14: operatorActionParams
                    {
                    pushFollow(FOLLOW_operatorActionParams_in_operatorAction950);
                    operatorActionParams93=operatorActionParams();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_operatorActionParams.add(operatorActionParams93.getTree());

                    }
                    break;

            }



            // AST REWRITE
            // elements: operatorActionParams, OPERATOR
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 226:4: -> ^( VT_OPERATOR_ACTION OPERATOR ( operatorActionParams )? )
            {
                // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:226:7: ^( VT_OPERATOR_ACTION OPERATOR ( operatorActionParams )? )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_OPERATOR_ACTION, "VT_OPERATOR_ACTION"), root_1);

                adaptor.addChild(root_1, stream_OPERATOR.nextNode());
                // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:226:37: ( operatorActionParams )?
                if ( stream_operatorActionParams.hasNext() ) {
                    adaptor.addChild(root_1, stream_operatorActionParams.nextTree());

                }
                stream_operatorActionParams.reset();

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
            if ( state.backtracking==0 ) {
               initialisePositionFromChild(retval.tree, 0); 
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "operatorAction"

    public static class operatorActionParams_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "operatorActionParams"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:229:1: operatorActionParams : expression ( ( AND | FROM | TO | WITH | USING ) expression )* ;
    public final NRLActionParser.operatorActionParams_return operatorActionParams() throws RecognitionException {
        NRLActionParser.operatorActionParams_return retval = new NRLActionParser.operatorActionParams_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token AND95=null;
        Token FROM96=null;
        Token TO97=null;
        Token WITH98=null;
        Token USING99=null;
        NRLActionParser_NRLConstraintRules.expression_return expression94 = null;

        NRLActionParser_NRLConstraintRules.expression_return expression100 = null;


        CommonTree AND95_tree=null;
        CommonTree FROM96_tree=null;
        CommonTree TO97_tree=null;
        CommonTree WITH98_tree=null;
        CommonTree USING99_tree=null;

        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:229:21: ( expression ( ( AND | FROM | TO | WITH | USING ) expression )* )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:230:4: expression ( ( AND | FROM | TO | WITH | USING ) expression )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_expression_in_operatorActionParams980);
            expression94=expression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, expression94.getTree());
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:230:15: ( ( AND | FROM | TO | WITH | USING ) expression )*
            loop21:
            do {
                int alt21=2;
                switch ( input.LA(1) ) {
                case AND:
                case FROM:
                case TO:
                case WITH:
                case USING:
                    {
                    alt21=1;
                    }
                    break;

                }

                switch (alt21) {
            	case 1 :
            	    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:230:17: ( AND | FROM | TO | WITH | USING ) expression
            	    {
            	    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:230:17: ( AND | FROM | TO | WITH | USING )
            	    int alt20=5;
            	    switch ( input.LA(1) ) {
            	    case AND:
            	        {
            	        alt20=1;
            	        }
            	        break;
            	    case FROM:
            	        {
            	        alt20=2;
            	        }
            	        break;
            	    case TO:
            	        {
            	        alt20=3;
            	        }
            	        break;
            	    case WITH:
            	        {
            	        alt20=4;
            	        }
            	        break;
            	    case USING:
            	        {
            	        alt20=5;
            	        }
            	        break;
            	    default:
            	        if (state.backtracking>0) {state.failed=true; return retval;}
            	        NoViableAltException nvae =
            	            new NoViableAltException("", 20, 0, input);

            	        throw nvae;
            	    }

            	    switch (alt20) {
            	        case 1 :
            	            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:230:18: AND
            	            {
            	            AND95=(Token)match(input,AND,FOLLOW_AND_in_operatorActionParams985); if (state.failed) return retval;

            	            }
            	            break;
            	        case 2 :
            	            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:230:23: FROM
            	            {
            	            FROM96=(Token)match(input,FROM,FOLLOW_FROM_in_operatorActionParams988); if (state.failed) return retval;

            	            }
            	            break;
            	        case 3 :
            	            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:230:29: TO
            	            {
            	            TO97=(Token)match(input,TO,FOLLOW_TO_in_operatorActionParams991); if (state.failed) return retval;

            	            }
            	            break;
            	        case 4 :
            	            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:230:33: WITH
            	            {
            	            WITH98=(Token)match(input,WITH,FOLLOW_WITH_in_operatorActionParams994); if (state.failed) return retval;

            	            }
            	            break;
            	        case 5 :
            	            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:230:39: USING
            	            {
            	            USING99=(Token)match(input,USING,FOLLOW_USING_in_operatorActionParams997); if (state.failed) return retval;

            	            }
            	            break;

            	    }

            	    pushFollow(FOLLOW_expression_in_operatorActionParams1001);
            	    expression100=expression();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, expression100.getTree());

            	    }
            	    break;

            	default :
            	    break loop21;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "operatorActionParams"

    public static class forEachAction_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "forEachAction"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:233:1: forEachAction : ( EACH ( OF )? modelReference ( COMMA )? action SEMI -> ^( VT_FOREACH_ACTION modelReference action ) | EACH var= DOUBLE_QUOTED_STRING ( IN_COLLECTION )? ( OF )? modelReference ( COMMA )? action SEMI -> ^( VT_FOREACH_ACTION $var modelReference action ) );
    public final NRLActionParser.forEachAction_return forEachAction() throws RecognitionException {
        NRLActionParser.forEachAction_return retval = new NRLActionParser.forEachAction_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token var=null;
        Token EACH101=null;
        Token OF102=null;
        Token COMMA104=null;
        Token SEMI106=null;
        Token EACH107=null;
        Token IN_COLLECTION108=null;
        Token OF109=null;
        Token COMMA111=null;
        Token SEMI113=null;
        NRLActionParser_NRLConstraintRules.modelReference_return modelReference103 = null;

        NRLActionParser.action_return action105 = null;

        NRLActionParser_NRLConstraintRules.modelReference_return modelReference110 = null;

        NRLActionParser.action_return action112 = null;


        CommonTree var_tree=null;
        CommonTree EACH101_tree=null;
        CommonTree OF102_tree=null;
        CommonTree COMMA104_tree=null;
        CommonTree SEMI106_tree=null;
        CommonTree EACH107_tree=null;
        CommonTree IN_COLLECTION108_tree=null;
        CommonTree OF109_tree=null;
        CommonTree COMMA111_tree=null;
        CommonTree SEMI113_tree=null;
        RewriteRuleTokenStream stream_DOUBLE_QUOTED_STRING=new RewriteRuleTokenStream(adaptor,"token DOUBLE_QUOTED_STRING");
        RewriteRuleTokenStream stream_IN_COLLECTION=new RewriteRuleTokenStream(adaptor,"token IN_COLLECTION");
        RewriteRuleTokenStream stream_EACH=new RewriteRuleTokenStream(adaptor,"token EACH");
        RewriteRuleTokenStream stream_OF=new RewriteRuleTokenStream(adaptor,"token OF");
        RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleTokenStream stream_SEMI=new RewriteRuleTokenStream(adaptor,"token SEMI");
        RewriteRuleSubtreeStream stream_action=new RewriteRuleSubtreeStream(adaptor,"rule action");
        RewriteRuleSubtreeStream stream_modelReference=new RewriteRuleSubtreeStream(adaptor,"rule modelReference");
        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:235:3: ( EACH ( OF )? modelReference ( COMMA )? action SEMI -> ^( VT_FOREACH_ACTION modelReference action ) | EACH var= DOUBLE_QUOTED_STRING ( IN_COLLECTION )? ( OF )? modelReference ( COMMA )? action SEMI -> ^( VT_FOREACH_ACTION $var modelReference action ) )
            int alt27=2;
            switch ( input.LA(1) ) {
            case EACH:
                {
                switch ( input.LA(2) ) {
                case DOUBLE_QUOTED_STRING:
                    {
                    alt27=2;
                    }
                    break;
                case OF:
                case IDENTIFIER:
                    {
                    alt27=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 27, 1, input);

                    throw nvae;
                }

                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 27, 0, input);

                throw nvae;
            }

            switch (alt27) {
                case 1 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:235:5: EACH ( OF )? modelReference ( COMMA )? action SEMI
                    {
                    EACH101=(Token)match(input,EACH,FOLLOW_EACH_in_forEachAction1025); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_EACH.add(EACH101);

                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:235:10: ( OF )?
                    int alt22=2;
                    switch ( input.LA(1) ) {
                        case OF:
                            {
                            alt22=1;
                            }
                            break;
                    }

                    switch (alt22) {
                        case 1 :
                            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:235:10: OF
                            {
                            OF102=(Token)match(input,OF,FOLLOW_OF_in_forEachAction1027); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_OF.add(OF102);


                            }
                            break;

                    }

                    pushFollow(FOLLOW_modelReference_in_forEachAction1030);
                    modelReference103=modelReference();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_modelReference.add(modelReference103.getTree());
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:235:29: ( COMMA )?
                    int alt23=2;
                    switch ( input.LA(1) ) {
                        case COMMA:
                            {
                            alt23=1;
                            }
                            break;
                    }

                    switch (alt23) {
                        case 1 :
                            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:235:29: COMMA
                            {
                            COMMA104=(Token)match(input,COMMA,FOLLOW_COMMA_in_forEachAction1032); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_COMMA.add(COMMA104);


                            }
                            break;

                    }

                    pushFollow(FOLLOW_action_in_forEachAction1035);
                    action105=action();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_action.add(action105.getTree());
                    SEMI106=(Token)match(input,SEMI,FOLLOW_SEMI_in_forEachAction1037); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_SEMI.add(SEMI106);



                    // AST REWRITE
                    // elements: action, modelReference
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 236:4: -> ^( VT_FOREACH_ACTION modelReference action )
                    {
                        // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:236:7: ^( VT_FOREACH_ACTION modelReference action )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_FOREACH_ACTION, "VT_FOREACH_ACTION"), root_1);

                        adaptor.addChild(root_1, stream_modelReference.nextTree());
                        adaptor.addChild(root_1, stream_action.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:237:5: EACH var= DOUBLE_QUOTED_STRING ( IN_COLLECTION )? ( OF )? modelReference ( COMMA )? action SEMI
                    {
                    EACH107=(Token)match(input,EACH,FOLLOW_EACH_in_forEachAction1057); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_EACH.add(EACH107);

                    var=(Token)match(input,DOUBLE_QUOTED_STRING,FOLLOW_DOUBLE_QUOTED_STRING_in_forEachAction1061); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_DOUBLE_QUOTED_STRING.add(var);

                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:237:35: ( IN_COLLECTION )?
                    int alt24=2;
                    switch ( input.LA(1) ) {
                        case IN_COLLECTION:
                            {
                            alt24=1;
                            }
                            break;
                    }

                    switch (alt24) {
                        case 1 :
                            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:237:35: IN_COLLECTION
                            {
                            IN_COLLECTION108=(Token)match(input,IN_COLLECTION,FOLLOW_IN_COLLECTION_in_forEachAction1063); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_IN_COLLECTION.add(IN_COLLECTION108);


                            }
                            break;

                    }

                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:237:50: ( OF )?
                    int alt25=2;
                    switch ( input.LA(1) ) {
                        case OF:
                            {
                            alt25=1;
                            }
                            break;
                    }

                    switch (alt25) {
                        case 1 :
                            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:237:50: OF
                            {
                            OF109=(Token)match(input,OF,FOLLOW_OF_in_forEachAction1066); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_OF.add(OF109);


                            }
                            break;

                    }

                    pushFollow(FOLLOW_modelReference_in_forEachAction1069);
                    modelReference110=modelReference();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_modelReference.add(modelReference110.getTree());
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:237:69: ( COMMA )?
                    int alt26=2;
                    switch ( input.LA(1) ) {
                        case COMMA:
                            {
                            alt26=1;
                            }
                            break;
                    }

                    switch (alt26) {
                        case 1 :
                            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:237:69: COMMA
                            {
                            COMMA111=(Token)match(input,COMMA,FOLLOW_COMMA_in_forEachAction1071); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_COMMA.add(COMMA111);


                            }
                            break;

                    }

                    pushFollow(FOLLOW_action_in_forEachAction1074);
                    action112=action();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_action.add(action112.getTree());
                    SEMI113=(Token)match(input,SEMI,FOLLOW_SEMI_in_forEachAction1076); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_SEMI.add(SEMI113);



                    // AST REWRITE
                    // elements: modelReference, var, action
                    // token labels: var
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleTokenStream stream_var=new RewriteRuleTokenStream(adaptor,"token var",var);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 238:4: -> ^( VT_FOREACH_ACTION $var modelReference action )
                    {
                        // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:238:7: ^( VT_FOREACH_ACTION $var modelReference action )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_FOREACH_ACTION, "VT_FOREACH_ACTION"), root_1);

                        adaptor.addChild(root_1, stream_var.nextNode());
                        adaptor.addChild(root_1, stream_modelReference.nextTree());
                        adaptor.addChild(root_1, stream_action.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
            if ( state.backtracking==0 ) {
               initialisePositionFromChild(retval.tree, 0); 
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "forEachAction"

    public static class variableDeclarationAction_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "variableDeclarationAction"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:241:1: variableDeclarationAction : simpleVariableDeclaration -> ^( VT_VARIABLE_DECLARATION_ACTION simpleVariableDeclaration ) ;
    public final NRLActionParser.variableDeclarationAction_return variableDeclarationAction() throws RecognitionException {
        NRLActionParser.variableDeclarationAction_return retval = new NRLActionParser.variableDeclarationAction_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NRLActionParser_NRLConstraintRules.simpleVariableDeclaration_return simpleVariableDeclaration114 = null;


        RewriteRuleSubtreeStream stream_simpleVariableDeclaration=new RewriteRuleSubtreeStream(adaptor,"rule simpleVariableDeclaration");
        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:243:3: ( simpleVariableDeclaration -> ^( VT_VARIABLE_DECLARATION_ACTION simpleVariableDeclaration ) )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:243:5: simpleVariableDeclaration
            {
            pushFollow(FOLLOW_simpleVariableDeclaration_in_variableDeclarationAction1112);
            simpleVariableDeclaration114=simpleVariableDeclaration();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_simpleVariableDeclaration.add(simpleVariableDeclaration114.getTree());


            // AST REWRITE
            // elements: simpleVariableDeclaration
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 244:4: -> ^( VT_VARIABLE_DECLARATION_ACTION simpleVariableDeclaration )
            {
                // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:244:7: ^( VT_VARIABLE_DECLARATION_ACTION simpleVariableDeclaration )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_VARIABLE_DECLARATION_ACTION, "VT_VARIABLE_DECLARATION_ACTION"), root_1);

                adaptor.addChild(root_1, stream_simpleVariableDeclaration.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
            if ( state.backtracking==0 ) {
               initialisePositionFromChild(retval.tree, 0); 
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "variableDeclarationAction"

    // $ANTLR start synpred1_NRLActionParser
    public final void synpred1_NRLActionParser_fragment() throws RecognitionException {   
        // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:121:5: ( context VALIDATION_RULE )
        // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:121:6: context VALIDATION_RULE
        {
        pushFollow(FOLLOW_context_in_synpred1_NRLActionParser222);
        context();

        state._fsp--;
        if (state.failed) return ;
        match(input,VALIDATION_RULE,FOLLOW_VALIDATION_RULE_in_synpred1_NRLActionParser224); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred1_NRLActionParser

    // $ANTLR start synpred2_NRLActionParser
    public final void synpred2_NRLActionParser_fragment() throws RecognitionException {   
        // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:122:5: ( VALIDATION_RULE )
        // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:122:6: VALIDATION_RULE
        {
        match(input,VALIDATION_RULE,FOLLOW_VALIDATION_RULE_in_synpred2_NRLActionParser236); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred2_NRLActionParser

    // $ANTLR start synpred3_NRLActionParser
    public final void synpred3_NRLActionParser_fragment() throws RecognitionException {   
        // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:123:5: ( actionContext ACTION_RULE )
        // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:123:6: actionContext ACTION_RULE
        {
        pushFollow(FOLLOW_actionContext_in_synpred3_NRLActionParser248);
        actionContext();

        state._fsp--;
        if (state.failed) return ;
        match(input,ACTION_RULE,FOLLOW_ACTION_RULE_in_synpred3_NRLActionParser250); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred3_NRLActionParser

    // $ANTLR start synpred4_NRLActionParser
    public final void synpred4_NRLActionParser_fragment() throws RecognitionException {   
        // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:124:5: ( ACTION_RULE )
        // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:124:6: ACTION_RULE
        {
        match(input,ACTION_RULE,FOLLOW_ACTION_RULE_in_synpred4_NRLActionParser262); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred4_NRLActionParser

    // $ANTLR start synpred5_NRLActionParser
    public final void synpred5_NRLActionParser_fragment() throws RecognitionException {   
        // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:125:5: ( multipleContext ACTION_FRAGMENT )
        // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:125:6: multipleContext ACTION_FRAGMENT
        {
        pushFollow(FOLLOW_multipleContext_in_synpred5_NRLActionParser274);
        multipleContext();

        state._fsp--;
        if (state.failed) return ;
        match(input,ACTION_FRAGMENT,FOLLOW_ACTION_FRAGMENT_in_synpred5_NRLActionParser276); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred5_NRLActionParser

    // $ANTLR start synpred6_NRLActionParser
    public final void synpred6_NRLActionParser_fragment() throws RecognitionException {   
        // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:180:5: ( REMOVE modelReference FROM )
        // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:180:6: REMOVE modelReference FROM
        {
        match(input,REMOVE,FOLLOW_REMOVE_in_synpred6_NRLActionParser617); if (state.failed) return ;
        pushFollow(FOLLOW_modelReference_in_synpred6_NRLActionParser619);
        modelReference();

        state._fsp--;
        if (state.failed) return ;
        match(input,FROM,FOLLOW_FROM_in_synpred6_NRLActionParser621); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred6_NRLActionParser

    // Delegated rules
    public NRLActionParser_NRLConstraintRules.validationRuleDeclaration_return validationRuleDeclaration() throws RecognitionException { return gNRLConstraintRules.validationRuleDeclaration(); }
    public NRLActionParser_NRLConstraintRules.impliesStatement_return impliesStatement() throws RecognitionException { return gNRLConstraintRules.impliesStatement(); }
    public NRLActionParser_NRLConstraintRules.enumerator_return enumerator() throws RecognitionException { return gNRLConstraintRules.enumerator(); }
    public NRLActionParser_NRLConstraintRules.multiplyExpression_return multiplyExpression() throws RecognitionException { return gNRLConstraintRules.multiplyExpression(); }
    public NRLActionParser_NRLConstraintRules.forallStatement_return forallStatement() throws RecognitionException { return gNRLConstraintRules.forallStatement(); }
    public NRLActionParser_NRLConstraintRules.predicateStatement_return predicateStatement() throws RecognitionException { return gNRLConstraintRules.predicateStatement(); }
    public NRLActionParser_NRLConstraintRules.modelReference_return modelReference() throws RecognitionException { return gNRLConstraintRules.modelReference(); }
    public NRLActionParser_NRLConstraintRules.listDefinition_return listDefinition() throws RecognitionException { return gNRLConstraintRules.listDefinition(); }
    public NRLActionParser_NRLConstraintRules.compoundReport_return compoundReport() throws RecognitionException { return gNRLConstraintRules.compoundReport(); }
    public NRLActionParser_NRLConstraintRules.addExpression_return addExpression() throws RecognitionException { return gNRLConstraintRules.addExpression(); }
    public NRLActionParser_NRLConstraintRules.simpleVariableDeclaration_return simpleVariableDeclaration() throws RecognitionException { return gNRLConstraintRules.simpleVariableDeclaration(); }
    public NRLActionParser_NRLConstraintRules.iffStatement_return iffStatement() throws RecognitionException { return gNRLConstraintRules.iffStatement(); }
    public NRLActionParser_NRLConstraintRules.castExpression_return castExpression() throws RecognitionException { return gNRLConstraintRules.castExpression(); }
    public NRLActionParser_NRLConstraintRules.additionalContextList_return additionalContextList() throws RecognitionException { return gNRLConstraintRules.additionalContextList(); }
    public NRLActionParser_NRLConstraintRules.globalVariableDeclaration_return globalVariableDeclaration() throws RecognitionException { return gNRLConstraintRules.globalVariableDeclaration(); }
    public NRLActionParser_NRLConstraintRules.validationFragmentDeclaration_return validationFragmentDeclaration() throws RecognitionException { return gNRLConstraintRules.validationFragmentDeclaration(); }
    public NRLActionParser_NRLConstraintRules.infixPropertyApplication_return infixPropertyApplication() throws RecognitionException { return gNRLConstraintRules.infixPropertyApplication(); }
    public NRLActionParser_NRLConstraintRules.multipleExistsStatement_return multipleExistsStatement() throws RecognitionException { return gNRLConstraintRules.multipleExistsStatement(); }
    public NRLActionParser_NRLConstraintRules.enumeratorDisambiguation_return enumeratorDisambiguation() throws RecognitionException { return gNRLConstraintRules.enumeratorDisambiguation(); }
    public NRLActionParser_NRLConstraintRules.namedParameterEntry_return namedParameterEntry() throws RecognitionException { return gNRLConstraintRules.namedParameterEntry(); }
    public NRLActionParser_NRLConstraintRules.multipleContext_return multipleContext() throws RecognitionException { return gNRLConstraintRules.multipleContext(); }
    public NRLActionParser_NRLConstraintRules.infixOperatorExpression_return infixOperatorExpression() throws RecognitionException { return gNRLConstraintRules.infixOperatorExpression(); }
    public NRLActionParser_NRLConstraintRules.existsStatement_return existsStatement() throws RecognitionException { return gNRLConstraintRules.existsStatement(); }
    public NRLActionParser_NRLConstraintRules.andStatement_return andStatement() throws RecognitionException { return gNRLConstraintRules.andStatement(); }
    public NRLActionParser_NRLConstraintRules.operatorInvocation_return operatorInvocation() throws RecognitionException { return gNRLConstraintRules.operatorInvocation(); }
    public NRLActionParser_NRLConstraintRules.modelReferenceList_return modelReferenceList() throws RecognitionException { return gNRLConstraintRules.modelReferenceList(); }
    public NRLActionParser_NRLConstraintRules.notExistsStatement_return notExistsStatement() throws RecognitionException { return gNRLConstraintRules.notExistsStatement(); }
    public NRLActionParser_NRLConstraintRules.simpleReports_return simpleReports() throws RecognitionException { return gNRLConstraintRules.simpleReports(); }
    public NRLActionParser_NRLConstraintRules.simpleOrComplexConstraint_return simpleOrComplexConstraint() throws RecognitionException { return gNRLConstraintRules.simpleOrComplexConstraint(); }
    public NRLActionParser_NRLConstraintRules.enumeratorStart_return enumeratorStart() throws RecognitionException { return gNRLConstraintRules.enumeratorStart(); }
    public NRLActionParser_NRLConstraintRules.number_return number() throws RecognitionException { return gNRLConstraintRules.number(); }
    public NRLActionParser_NRLConstraintRules.conditionalReport_return conditionalReport() throws RecognitionException { return gNRLConstraintRules.conditionalReport(); }
    public NRLActionParser_NRLConstraintRules.context_return context() throws RecognitionException { return gNRLConstraintRules.context(); }
    public NRLActionParser_NRLConstraintRules.logicalStatement_return logicalStatement() throws RecognitionException { return gNRLConstraintRules.logicalStatement(); }
    public NRLActionParser_NRLConstraintRules.forallStart_return forallStart() throws RecognitionException { return gNRLConstraintRules.forallStart(); }
    public NRLActionParser_NRLConstraintRules.propertyApplication_return propertyApplication() throws RecognitionException { return gNRLConstraintRules.propertyApplication(); }
    public NRLActionParser_NRLConstraintRules.selectionExpression_return selectionExpression() throws RecognitionException { return gNRLConstraintRules.selectionExpression(); }
    public NRLActionParser_NRLConstraintRules.collectionIndex_return collectionIndex() throws RecognitionException { return gNRLConstraintRules.collectionIndex(); }
    public NRLActionParser_NRLConstraintRules.ruleSetDeclaration_return ruleSetDeclaration() throws RecognitionException { return gNRLConstraintRules.ruleSetDeclaration(); }
    public NRLActionParser_NRLConstraintRules.expression_return expression() throws RecognitionException { return gNRLConstraintRules.expression(); }
    public NRLActionParser_NRLConstraintRules.statement_return statement() throws RecognitionException { return gNRLConstraintRules.statement(); }
    public NRLActionParser_NRLConstraintRules.concatenatedReport_return concatenatedReport() throws RecognitionException { return gNRLConstraintRules.concatenatedReport(); }
    public NRLActionParser_NRLConstraintRules.concatenatedReportTerms_return concatenatedReportTerms() throws RecognitionException { return gNRLConstraintRules.concatenatedReportTerms(); }
    public NRLActionParser_NRLConstraintRules.constraint_return constraint() throws RecognitionException { return gNRLConstraintRules.constraint(); }
    public NRLActionParser_NRLConstraintRules.validationRuleVariableDeclaration_return validationRuleVariableDeclaration() throws RecognitionException { return gNRLConstraintRules.validationRuleVariableDeclaration(); }
    public NRLActionParser_NRLConstraintRules.identifier_return identifier() throws RecognitionException { return gNRLConstraintRules.identifier(); }
    public NRLActionParser_NRLConstraintRules.identifierSequence_return identifierSequence() throws RecognitionException { return gNRLConstraintRules.identifierSequence(); }
    public NRLActionParser_NRLConstraintRules.constraintRuleReport_return constraintRuleReport() throws RecognitionException { return gNRLConstraintRules.constraintRuleReport(); }
    public NRLActionParser_NRLConstraintRules.simpleReport_return simpleReport() throws RecognitionException { return gNRLConstraintRules.simpleReport(); }
    public NRLActionParser_NRLConstraintRules.simpleTerm_return simpleTerm() throws RecognitionException { return gNRLConstraintRules.simpleTerm(); }
    public NRLActionParser_NRLConstraintRules.isSubtypePredicate_return isSubtypePredicate() throws RecognitionException { return gNRLConstraintRules.isSubtypePredicate(); }
    public NRLActionParser_NRLConstraintRules.operatorParameterList_return operatorParameterList() throws RecognitionException { return gNRLConstraintRules.operatorParameterList(); }
    public NRLActionParser_NRLConstraintRules.globalExistsStatement_return globalExistsStatement() throws RecognitionException { return gNRLConstraintRules.globalExistsStatement(); }
    public NRLActionParser_NRLConstraintRules.orStatement_return orStatement() throws RecognitionException { return gNRLConstraintRules.orStatement(); }
    public NRLActionParser_NRLConstraintRules.functionalExpression_return functionalExpression() throws RecognitionException { return gNRLConstraintRules.functionalExpression(); }
    public NRLActionParser_NRLConstraintRules.term_return term() throws RecognitionException { return gNRLConstraintRules.term(); }
    public NRLActionParser_NRLConstraintRules.multipleNotExistsStatement_return multipleNotExistsStatement() throws RecognitionException { return gNRLConstraintRules.multipleNotExistsStatement(); }

    public final boolean synpred6_NRLActionParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred6_NRLActionParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred2_NRLActionParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred2_NRLActionParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred1_NRLActionParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred1_NRLActionParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred5_NRLActionParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred5_NRLActionParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred3_NRLActionParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred3_NRLActionParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred4_NRLActionParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred4_NRLActionParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }


    protected DFA4 dfa4 = new DFA4(this);
    protected DFA11 dfa11 = new DFA11(this);
    protected DFA12 dfa12 = new DFA12(this);
    protected DFA19 dfa19 = new DFA19(this);
    static final String DFA4_eotS =
        "\14\uffff";
    static final String DFA4_eofS =
        "\14\uffff";
    static final String DFA4_minS =
        "\1\24\3\0\10\uffff";
    static final String DFA4_maxS =
        "\1\145\3\0\10\uffff";
    static final String DFA4_acceptS =
        "\4\uffff\1\6\1\7\1\1\1\2\1\3\1\4\1\5\1\10";
    static final String DFA4_specialS =
        "\1\uffff\1\0\1\1\1\2\10\uffff}>";
    static final String[] DFA4_transitionS = {
            "\1\2\1\4\5\uffff\1\5\3\uffff\1\1\105\uffff\1\3",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA4_eot = DFA.unpackEncodedString(DFA4_eotS);
    static final short[] DFA4_eof = DFA.unpackEncodedString(DFA4_eofS);
    static final char[] DFA4_min = DFA.unpackEncodedStringToUnsignedChars(DFA4_minS);
    static final char[] DFA4_max = DFA.unpackEncodedStringToUnsignedChars(DFA4_maxS);
    static final short[] DFA4_accept = DFA.unpackEncodedString(DFA4_acceptS);
    static final short[] DFA4_special = DFA.unpackEncodedString(DFA4_specialS);
    static final short[][] DFA4_transition;

    static {
        int numStates = DFA4_transitionS.length;
        DFA4_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA4_transition[i] = DFA.unpackEncodedString(DFA4_transitionS[i]);
        }
    }

    class DFA4 extends DFA {

        public DFA4(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 4;
            this.eot = DFA4_eot;
            this.eof = DFA4_eof;
            this.min = DFA4_min;
            this.max = DFA4_max;
            this.accept = DFA4_accept;
            this.special = DFA4_special;
            this.transition = DFA4_transition;
        }
        public String getDescription() {
            return "120:1: declaration : ( ( context VALIDATION_RULE )=> validationRuleDeclaration | ( VALIDATION_RULE )=> validationRuleDeclaration | ( actionContext ACTION_RULE )=> actionRuleDeclaration | ( ACTION_RULE )=> actionRuleDeclaration | ( multipleContext ACTION_FRAGMENT )=> actionFragmentDeclaration | globalVariableDeclaration | ruleSetDeclaration | validationFragmentDeclaration );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA4_1 = input.LA(1);

                         
                        int index4_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred1_NRLActionParser()) ) {s = 6;}

                        else if ( (synpred2_NRLActionParser()) ) {s = 7;}

                        else if ( (synpred3_NRLActionParser()) ) {s = 8;}

                        else if ( (synpred4_NRLActionParser()) ) {s = 9;}

                        else if ( (synpred5_NRLActionParser()) ) {s = 10;}

                        else if ( (true) ) {s = 11;}

                         
                        input.seek(index4_1);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA4_2 = input.LA(1);

                         
                        int index4_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred1_NRLActionParser()) ) {s = 6;}

                        else if ( (synpred2_NRLActionParser()) ) {s = 7;}

                         
                        input.seek(index4_2);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA4_3 = input.LA(1);

                         
                        int index4_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred3_NRLActionParser()) ) {s = 8;}

                        else if ( (synpred4_NRLActionParser()) ) {s = 9;}

                         
                        input.seek(index4_3);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 4, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA11_eotS =
        "\23\uffff";
    static final String DFA11_eofS =
        "\1\1\22\uffff";
    static final String DFA11_minS =
        "\1\24\22\uffff";
    static final String DFA11_maxS =
        "\1\153\22\uffff";
    static final String DFA11_acceptS =
        "\1\uffff\1\2\3\uffff\1\1\3\uffff\1\1\11\uffff";
    static final String DFA11_specialS =
        "\23\uffff}>";
    static final String[] DFA11_transitionS = {
            "\1\1\1\5\3\uffff\1\11\1\uffff\1\1\3\uffff\1\1\2\uffff\2\11"+
            "\1\1\22\uffff\1\11\21\uffff\2\11\20\uffff\1\1\11\uffff\1\1\1"+
            "\uffff\1\11\1\uffff\3\11",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA11_eot = DFA.unpackEncodedString(DFA11_eotS);
    static final short[] DFA11_eof = DFA.unpackEncodedString(DFA11_eofS);
    static final char[] DFA11_min = DFA.unpackEncodedStringToUnsignedChars(DFA11_minS);
    static final char[] DFA11_max = DFA.unpackEncodedStringToUnsignedChars(DFA11_maxS);
    static final short[] DFA11_accept = DFA.unpackEncodedString(DFA11_acceptS);
    static final short[] DFA11_special = DFA.unpackEncodedString(DFA11_specialS);
    static final short[][] DFA11_transition;

    static {
        int numStates = DFA11_transitionS.length;
        DFA11_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA11_transition[i] = DFA.unpackEncodedString(DFA11_transitionS[i]);
        }
    }

    class DFA11 extends DFA {

        public DFA11(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 11;
            this.eot = DFA11_eot;
            this.eof = DFA11_eof;
            this.min = DFA11_min;
            this.max = DFA11_max;
            this.accept = DFA11_accept;
            this.special = DFA11_special;
            this.transition = DFA11_transition;
        }
        public String getDescription() {
            return "()* loopback of 175:18: ( ( COMMA )? ( THEN )? simpleAction )*";
        }
    }
    static final String DFA12_eotS =
        "\14\uffff";
    static final String DFA12_eofS =
        "\14\uffff";
    static final String DFA12_minS =
        "\1\25\1\uffff\1\0\11\uffff";
    static final String DFA12_maxS =
        "\1\153\1\uffff\1\0\11\uffff";
    static final String DFA12_acceptS =
        "\1\uffff\1\1\1\uffff\1\4\1\5\1\6\1\7\1\10\1\11\1\12\1\2\1\3";
    static final String DFA12_specialS =
        "\2\uffff\1\0\11\uffff}>";
    static final String[] DFA12_transitionS = {
            "\1\10\14\uffff\1\11\24\uffff\1\7\21\uffff\1\5\1\6\34\uffff"+
            "\1\1\1\uffff\1\2\1\3\1\4",
            "",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA12_eot = DFA.unpackEncodedString(DFA12_eotS);
    static final short[] DFA12_eof = DFA.unpackEncodedString(DFA12_eofS);
    static final char[] DFA12_min = DFA.unpackEncodedStringToUnsignedChars(DFA12_minS);
    static final char[] DFA12_max = DFA.unpackEncodedStringToUnsignedChars(DFA12_maxS);
    static final short[] DFA12_accept = DFA.unpackEncodedString(DFA12_acceptS);
    static final short[] DFA12_special = DFA.unpackEncodedString(DFA12_specialS);
    static final short[][] DFA12_transition;

    static {
        int numStates = DFA12_transitionS.length;
        DFA12_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA12_transition[i] = DFA.unpackEncodedString(DFA12_transitionS[i]);
        }
    }

    class DFA12 extends DFA {

        public DFA12(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 12;
            this.eot = DFA12_eot;
            this.eof = DFA12_eof;
            this.min = DFA12_min;
            this.max = DFA12_max;
            this.accept = DFA12_accept;
            this.special = DFA12_special;
            this.transition = DFA12_transition;
        }
        public String getDescription() {
            return "178:1: simpleAction : ( createAction | ( REMOVE modelReference FROM )=> removeFromCollectionAction | removeAction | setAction | addAction | operatorAction | macroApplicationAction | forEachAction | variableDeclarationAction | conditionalAction );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA12_2 = input.LA(1);

                         
                        int index12_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred6_NRLActionParser()) ) {s = 10;}

                        else if ( (true) ) {s = 11;}

                         
                        input.seek(index12_2);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 12, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA19_eotS =
        "\36\uffff";
    static final String DFA19_eofS =
        "\1\16\35\uffff";
    static final String DFA19_minS =
        "\1\24\35\uffff";
    static final String DFA19_maxS =
        "\1\153\35\uffff";
    static final String DFA19_acceptS =
        "\1\uffff\2\1\13\uffff\1\2\17\uffff";
    static final String DFA19_specialS =
        "\36\uffff}>";
    static final String[] DFA19_transitionS = {
            "\2\16\3\uffff\1\16\1\uffff\1\16\3\uffff\1\16\1\1\1\uffff\3"+
            "\16\15\uffff\1\1\4\uffff\1\16\15\uffff\1\1\3\uffff\1\1\1\2\4"+
            "\uffff\2\1\3\uffff\6\1\1\uffff\1\16\11\uffff\1\16\1\uffff\1"+
            "\16\1\uffff\3\16",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA19_eot = DFA.unpackEncodedString(DFA19_eotS);
    static final short[] DFA19_eof = DFA.unpackEncodedString(DFA19_eofS);
    static final char[] DFA19_min = DFA.unpackEncodedStringToUnsignedChars(DFA19_minS);
    static final char[] DFA19_max = DFA.unpackEncodedStringToUnsignedChars(DFA19_maxS);
    static final short[] DFA19_accept = DFA.unpackEncodedString(DFA19_acceptS);
    static final short[] DFA19_special = DFA.unpackEncodedString(DFA19_specialS);
    static final short[][] DFA19_transition;

    static {
        int numStates = DFA19_transitionS.length;
        DFA19_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA19_transition[i] = DFA.unpackEncodedString(DFA19_transitionS[i]);
        }
    }

    class DFA19 extends DFA {

        public DFA19(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 19;
            this.eot = DFA19_eot;
            this.eof = DFA19_eof;
            this.min = DFA19_min;
            this.max = DFA19_max;
            this.accept = DFA19_accept;
            this.special = DFA19_special;
            this.transition = DFA19_transition;
        }
        public String getDescription() {
            return "225:14: ( operatorActionParams )?";
        }
    }
 

    public static final BitSet FOLLOW_modelFileReferences_in_fileBody96 = new BitSet(new long[]{0x0000000088300000L,0x0000003000000000L});
    public static final BitSet FOLLOW_operatorFileReferences_in_fileBody98 = new BitSet(new long[]{0x0000000088300000L,0x0000002000000000L});
    public static final BitSet FOLLOW_declarations_in_fileBody100 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_fileBody102 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_modelFileReference_in_modelFileReferences135 = new BitSet(new long[]{0x0000000000000002L,0x0000000800000000L});
    public static final BitSet FOLLOW_MODEL_in_modelFileReference150 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_DOUBLE_QUOTED_STRING_in_modelFileReference153 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_operatorFileReference_in_operatorFileReferences169 = new BitSet(new long[]{0x0000000000000002L,0x0000001000000000L});
    public static final BitSet FOLLOW_OPERATORS_in_operatorFileReference184 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_DOUBLE_QUOTED_STRING_in_operatorFileReference187 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_declaration_in_declarations205 = new BitSet(new long[]{0x0000000088300002L,0x0000002000000000L});
    public static final BitSet FOLLOW_validationRuleDeclaration_in_declaration229 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_validationRuleDeclaration_in_declaration241 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionRuleDeclaration_in_declaration255 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionRuleDeclaration_in_declaration267 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionFragmentDeclaration_in_declaration281 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_globalVariableDeclaration_in_declaration287 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleSetDeclaration_in_declaration293 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_validationFragmentDeclaration_in_declaration299 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionContext_in_actionRuleDeclaration316 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_ACTION_RULE_in_actionRuleDeclaration318 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_DOUBLE_QUOTED_STRING_in_actionRuleDeclaration321 = new BitSet(new long[]{0x0080000400200000L,0x00000E8000000600L});
    public static final BitSet FOLLOW_action_in_actionRuleDeclaration323 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ACTION_RULE_in_actionRuleDeclaration329 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_DOUBLE_QUOTED_STRING_in_actionRuleDeclaration332 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_APPLIES_TO_in_actionRuleDeclaration334 = new BitSet(new long[]{0x0000000000000000L,0x0000000002000000L});
    public static final BitSet FOLLOW_modelReference_in_actionRuleDeclaration337 = new BitSet(new long[]{0x0080000400A00000L,0x00000E8000000600L});
    public static final BitSet FOLLOW_AND_in_actionRuleDeclaration341 = new BitSet(new long[]{0x0000000001000000L});
    public static final BitSet FOLLOW_USES_in_actionRuleDeclaration344 = new BitSet(new long[]{0x0000000000000000L,0x0000000002000000L});
    public static final BitSet FOLLOW_additionalContextList_in_actionRuleDeclaration347 = new BitSet(new long[]{0x0080000400200000L,0x00000E8000000600L});
    public static final BitSet FOLLOW_action_in_actionRuleDeclaration352 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_multipleContext_in_actionFragmentDeclaration367 = new BitSet(new long[]{0x0000000000000000L,0x0000004000000000L});
    public static final BitSet FOLLOW_ACTION_FRAGMENT_in_actionFragmentDeclaration369 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_DOUBLE_QUOTED_STRING_in_actionFragmentDeclaration372 = new BitSet(new long[]{0x0080000400200000L,0x00000E8000000600L});
    public static final BitSet FOLLOW_action_in_actionFragmentDeclaration374 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_CONTEXT_in_actionContext387 = new BitSet(new long[]{0x0000000000000000L,0x0000000002000000L});
    public static final BitSet FOLLOW_modelReference_in_actionContext390 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_CONTEXT_in_actionContext396 = new BitSet(new long[]{0x0008000000000000L});
    public static final BitSet FOLLOW_NO_in_actionContext399 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_action_in_singleActionAndEOF413 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_singleActionAndEOF415 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_compoundAction_in_action431 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IF_in_conditionalAction451 = new BitSet(new long[]{0x00AFFC0500000000L,0x0000000003F18624L});
    public static final BitSet FOLLOW_statement_in_conditionalAction455 = new BitSet(new long[]{0x0000000800000000L});
    public static final BitSet FOLLOW_THEN_in_conditionalAction457 = new BitSet(new long[]{0x0080000400200000L,0x00000E8000000600L});
    public static final BitSet FOLLOW_action_in_conditionalAction461 = new BitSet(new long[]{0x0000001000000000L,0x0000000008000000L});
    public static final BitSet FOLLOW_ELSE_in_conditionalAction498 = new BitSet(new long[]{0x0080000400200000L,0x00000E8000000600L});
    public static final BitSet FOLLOW_action_in_conditionalAction502 = new BitSet(new long[]{0x0000000000000000L,0x0000000008000000L});
    public static final BitSet FOLLOW_SEMI_in_conditionalAction513 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_simpleActionList_in_compoundAction550 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_simpleAction_in_simpleActionList576 = new BitSet(new long[]{0x0080000C02200002L,0x00000E8000000600L});
    public static final BitSet FOLLOW_COMMA_in_simpleActionList581 = new BitSet(new long[]{0x0080000C00200000L,0x00000E8000000600L});
    public static final BitSet FOLLOW_THEN_in_simpleActionList587 = new BitSet(new long[]{0x0080000400200000L,0x00000E8000000600L});
    public static final BitSet FOLLOW_simpleAction_in_simpleActionList592 = new BitSet(new long[]{0x0080000C02200002L,0x00000E8000000600L});
    public static final BitSet FOLLOW_createAction_in_simpleAction610 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_removeFromCollectionAction_in_simpleAction626 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_removeAction_in_simpleAction632 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_setAction_in_simpleAction638 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_addAction_in_simpleAction644 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_operatorAction_in_simpleAction650 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_macroApplicationAction_in_simpleAction656 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_forEachAction_in_simpleAction662 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_variableDeclarationAction_in_simpleAction668 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionalAction_in_simpleAction674 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_CREATE_in_createAction690 = new BitSet(new long[]{0x0000000000000000L,0x0000010000000000L});
    public static final BitSet FOLLOW_NEW_in_createAction693 = new BitSet(new long[]{0x0000000000000000L,0x0000000002000000L});
    public static final BitSet FOLLOW_modelReference_in_createAction696 = new BitSet(new long[]{0x0000000100000002L});
    public static final BitSet FOLLOW_LPAREN_in_createAction699 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_DOUBLE_QUOTED_STRING_in_createAction704 = new BitSet(new long[]{0x0000000200000000L});
    public static final BitSet FOLLOW_RPAREN_in_createAction706 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_REMOVE_in_removeAction724 = new BitSet(new long[]{0x0080010000000000L,0x0000000002000000L});
    public static final BitSet FOLLOW_EACH_in_removeAction728 = new BitSet(new long[]{0x0000010000000000L,0x0000000002000000L});
    public static final BitSet FOLLOW_OF_in_removeAction734 = new BitSet(new long[]{0x0000000000000000L,0x0000000002000000L});
    public static final BitSet FOLLOW_modelReference_in_removeAction739 = new BitSet(new long[]{0x0000000100000002L});
    public static final BitSet FOLLOW_LPAREN_in_removeAction742 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_DOUBLE_QUOTED_STRING_in_removeAction747 = new BitSet(new long[]{0x0000000200000000L});
    public static final BitSet FOLLOW_RPAREN_in_removeAction749 = new BitSet(new long[]{0x0000000010000000L});
    public static final BitSet FOLLOW_WHERE_in_removeAction752 = new BitSet(new long[]{0x00AFFC0500000000L,0x0000000003F18624L});
    public static final BitSet FOLLOW_constraint_in_removeAction755 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_REMOVE_in_removeFromCollectionAction777 = new BitSet(new long[]{0x0000000000000000L,0x0000000002000000L});
    public static final BitSet FOLLOW_modelReference_in_removeFromCollectionAction781 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_FROM_in_removeFromCollectionAction783 = new BitSet(new long[]{0x0000000000000000L,0x0000000002000000L});
    public static final BitSet FOLLOW_modelReference_in_removeFromCollectionAction787 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SET_in_setAction817 = new BitSet(new long[]{0x0000000000000000L,0x0000000002000000L});
    public static final BitSet FOLLOW_modelReference_in_setAction820 = new BitSet(new long[]{0x0000000000000000L,0x0000000000001000L});
    public static final BitSet FOLLOW_TO_in_setAction822 = new BitSet(new long[]{0x0004000100000000L,0x0000000003F18620L});
    public static final BitSet FOLLOW_expression_in_setAction825 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ADD_VERB_in_addAction840 = new BitSet(new long[]{0x0000000000000000L,0x0000000002000000L});
    public static final BitSet FOLLOW_modelReference_in_addAction843 = new BitSet(new long[]{0x0000000000000000L,0x0000000000001000L});
    public static final BitSet FOLLOW_TO_in_addAction845 = new BitSet(new long[]{0x0000000000000000L,0x0000000002000000L});
    public static final BitSet FOLLOW_modelReference_in_addAction848 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PROPERTYNAME_in_macroApplicationAction870 = new BitSet(new long[]{0x0004000100000000L,0x0000000003F18620L});
    public static final BitSet FOLLOW_macroApplicationParams_in_macroApplicationAction874 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expression_in_macroApplicationParams904 = new BitSet(new long[]{0x0000000000800002L,0x0000000000007800L});
    public static final BitSet FOLLOW_AND_in_macroApplicationParams909 = new BitSet(new long[]{0x0004000100000000L,0x0000000003F18620L});
    public static final BitSet FOLLOW_FROM_in_macroApplicationParams912 = new BitSet(new long[]{0x0004000100000000L,0x0000000003F18620L});
    public static final BitSet FOLLOW_TO_in_macroApplicationParams915 = new BitSet(new long[]{0x0004000100000000L,0x0000000003F18620L});
    public static final BitSet FOLLOW_WITH_in_macroApplicationParams918 = new BitSet(new long[]{0x0004000100000000L,0x0000000003F18620L});
    public static final BitSet FOLLOW_USING_in_macroApplicationParams921 = new BitSet(new long[]{0x0004000100000000L,0x0000000003F18620L});
    public static final BitSet FOLLOW_expression_in_macroApplicationParams925 = new BitSet(new long[]{0x0000000000800002L,0x0000000000007800L});
    public static final BitSet FOLLOW_OPERATOR_in_operatorAction948 = new BitSet(new long[]{0x0004000100000002L,0x0000000003F18620L});
    public static final BitSet FOLLOW_operatorActionParams_in_operatorAction950 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expression_in_operatorActionParams980 = new BitSet(new long[]{0x0000000000800002L,0x0000000000007800L});
    public static final BitSet FOLLOW_AND_in_operatorActionParams985 = new BitSet(new long[]{0x0004000100000000L,0x0000000003F18620L});
    public static final BitSet FOLLOW_FROM_in_operatorActionParams988 = new BitSet(new long[]{0x0004000100000000L,0x0000000003F18620L});
    public static final BitSet FOLLOW_TO_in_operatorActionParams991 = new BitSet(new long[]{0x0004000100000000L,0x0000000003F18620L});
    public static final BitSet FOLLOW_WITH_in_operatorActionParams994 = new BitSet(new long[]{0x0004000100000000L,0x0000000003F18620L});
    public static final BitSet FOLLOW_USING_in_operatorActionParams997 = new BitSet(new long[]{0x0004000100000000L,0x0000000003F18620L});
    public static final BitSet FOLLOW_expression_in_operatorActionParams1001 = new BitSet(new long[]{0x0000000000800002L,0x0000000000007800L});
    public static final BitSet FOLLOW_EACH_in_forEachAction1025 = new BitSet(new long[]{0x0000010000000000L,0x0000000002000000L});
    public static final BitSet FOLLOW_OF_in_forEachAction1027 = new BitSet(new long[]{0x0000000000000000L,0x0000000002000000L});
    public static final BitSet FOLLOW_modelReference_in_forEachAction1030 = new BitSet(new long[]{0x0080000402200000L,0x00000E8000000600L});
    public static final BitSet FOLLOW_COMMA_in_forEachAction1032 = new BitSet(new long[]{0x0080000400200000L,0x00000E8000000600L});
    public static final BitSet FOLLOW_action_in_forEachAction1035 = new BitSet(new long[]{0x0000000000000000L,0x0000000008000000L});
    public static final BitSet FOLLOW_SEMI_in_forEachAction1037 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_EACH_in_forEachAction1057 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_DOUBLE_QUOTED_STRING_in_forEachAction1061 = new BitSet(new long[]{0x0100010000000000L,0x0000000002000000L});
    public static final BitSet FOLLOW_IN_COLLECTION_in_forEachAction1063 = new BitSet(new long[]{0x0000010000000000L,0x0000000002000000L});
    public static final BitSet FOLLOW_OF_in_forEachAction1066 = new BitSet(new long[]{0x0000000000000000L,0x0000000002000000L});
    public static final BitSet FOLLOW_modelReference_in_forEachAction1069 = new BitSet(new long[]{0x0080000402200000L,0x00000E8000000600L});
    public static final BitSet FOLLOW_COMMA_in_forEachAction1071 = new BitSet(new long[]{0x0080000400200000L,0x00000E8000000600L});
    public static final BitSet FOLLOW_action_in_forEachAction1074 = new BitSet(new long[]{0x0000000000000000L,0x0000000008000000L});
    public static final BitSet FOLLOW_SEMI_in_forEachAction1076 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_simpleVariableDeclaration_in_variableDeclarationAction1112 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_context_in_synpred1_NRLActionParser222 = new BitSet(new long[]{0x0000000000100000L});
    public static final BitSet FOLLOW_VALIDATION_RULE_in_synpred1_NRLActionParser224 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VALIDATION_RULE_in_synpred2_NRLActionParser236 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionContext_in_synpred3_NRLActionParser248 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_ACTION_RULE_in_synpred3_NRLActionParser250 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ACTION_RULE_in_synpred4_NRLActionParser262 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_multipleContext_in_synpred5_NRLActionParser274 = new BitSet(new long[]{0x0000000000000000L,0x0000004000000000L});
    public static final BitSet FOLLOW_ACTION_FRAGMENT_in_synpred5_NRLActionParser276 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_REMOVE_in_synpred6_NRLActionParser617 = new BitSet(new long[]{0x0000000000000000L,0x0000000002000000L});
    public static final BitSet FOLLOW_modelReference_in_synpred6_NRLActionParser619 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_FROM_in_synpred6_NRLActionParser621 = new BitSet(new long[]{0x0000000000000002L});

}